;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; 16-Bit Frame Counter, by imamelia
;;
;; This patch adds a second frame counter analogous to $13 that goes from
;; 0000-FFFF instead of just 00-FF.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

!Freespace = $99FFC0

!FrameCtr2 = $0F46

org $008070
JML UpdateFrameCounter
NOP #2

org !Freespace
dw End-Start-$01
dw End-Start-$01^$FFFF

Start:

UpdateFrameCounter:

CLI		;Restore Wait Replace Code
INC $13
REP #$20
INC !FrameCtr2
SEP #$20
PEA $8074
JML $809322

End:





