;========================;
;200 Digit Coin Counter  ;
;========================;

!Freespace = $1C9500
!CounterPos = $0F12		; Position on status bar.

Header
LoROM

org $8F7E
 NOP #6

org $8F2B
 CMP #200			; Give 1-up on 200 coins.

org $8F36
 SBC #200			; Subtract 200 coins after 1-up.

org $8F73
	JSL Tilemaps
	NOP #2
org !Freespace
!CodeSize = Ending-Routine 	
db "STAR"			
dw !CodeSize-$01
dw !CodeSize-$01^$FFFF
Routine:

Tilemaps:
	PHX
	PHY
	LDA $0DBF
	JSL Converter
	CPY #$00
	BNE .Y
	LDY #$FC
.Y	STY !CounterPos
	CPX #$00
	BNE .X
	CPY #$01
	BEQ .X
	LDX #$FC
.X	STX !CounterPos+1
	STA !CounterPos+2
	PLX
	PLY
	RTL
Converter:
	LDX #$00
	LDY #$00
Loopy:	CMP #$64
	BCC Loopx
	SBC #$64
	INY
	BRA Loopy
Loopx:	CMP #$0A
	BCC +
	SBC #$0A
	INX
	BRA Loopx
+	RTL

Ending: