!Freespace = $12C9BA

header
lorom

;-------------;
; Custom Code ;
;-------------;

org !Freespace ;Freespace

!CodeSize = End-CustomCode
db "STAR"
dw !CodeSize-$01
dw !CodeSize-$01^$FFFF

CustomCode: 
STZ $0DB3
LDA $0DB2		
BEQ EasyMode
LDA $71		;\
CMP #$01	; | uncomment for one hit kills
BEQ Kill	;/
DEC $0F30	;uncomment to speed up timer
EasyMode:
RTL

Kill:
LDA #$90             
STA $7D
LDA #$09                ; \ 
STA $1DFB               ; / Change music 
LDA #$FF                
STA $0DDA               
LDA #$09                ; \ Animation sequence = Kill Mario 
STA $71  		; / 
STZ $140D    		; Spin jump flag = 0 
LDA #$30                
STA $1496               ; Set hurt frame timer 
STA $9D  
STZ $1407               ; Cape status = 0 
STZ $188A               
RTL                     ; Return 

NoLuigi:
LDA #$08
STA $7B
LDA #$FF
STA $0DB5
STA $1F1D
RTL

End:

;-----------------;
; 1/2 PLAYER text ;
;-----------------;

org $05B872
db $51,$E5,$40,$2F	; \
db $FC,$38		;  |
db $52,$25,$40,$2F	;  |
db $FC,$38		;  | Mandatory clear routines.
db $52,$65,$40,$2F	;  |
db $FC,$38		;  |
db $52,$A5,$40,$2F	;  |
db $FC,$38		; /

db $52,$0A,$00,$15
db $17,$38 : db $18,$38 : db $1B,$38 : db $16,$38 : db $0A,$38 : db $15,$38	; \ NORMAL GAME
db $FC,$38 : db $10,$38 : db $0A,$38 : db $16,$38 : db $0E,$38			; /

db $52,$4A,$00,$11
db $11,$38 : db $0A,$38 : db $1B,$38 : db $0D,$38 : db $FC,$38 : db $10,$38	; \ HARD GAME
db $0A,$38 : db $16,$38 : db $0E,$38						; /
db $FF

; 12 bytes of freespace after this.
;---------------------;
; Hijacks & Hex Edits ;
;---------------------;

org $0086A0 
STZ $0DA0
LDA #$00
LDX #$00
NOP

org $0485BB
NOP
JSL NoLuigi

org $008EEF
JSL CustomCode
NOP 

org $04828D	;get rid of...
BRA $06
