;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Custom Game Modes, by imamelia
;
; This patch will allow you to use more values of $0100, the game mode RAM address.
; Normally, this goes from 00 to 29, where, for example, 07 is the title screen, 0E
; is the overworld, and 14 is a level.  But with this, you can use values 2A-FF for
; your own custom game modes.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

header
lorom

!Freespace = $1FD000          

org $009322
JML GameModeHack

org !Freespace

reset bytes

db "STAR"
dw EndCode-StartCode-$01
dw EndCode-StartCode-$01^$FFFF

StartCode:

GameModeHack:

LDA $0100		;
CMP #$2A		;
BCS NewGameModes	;
PHX			;
ASL			;
TAX			;
LDA $9329,x		;
STA $00			;
LDA $932A,x		;
STA $01			;
STZ $02			;
PLX			;
JML [$0000]		;

NewGameModes:

PHB			;
PHK			;
PLB			;
JSR ExecuteNewGameModePtr	;
PLB			;
JML $009312		;

ExecuteNewGameModePtr:	;

LDA $0100		;
SEC			;
SBC #$2A			;
JSL $0086DF		;

NewGameModePtrs:		;

; Put custom game modes here! I included pointers only for 2A-37, but you can add as many as you want up to FF.

dw GameMode2A		; 2A -
dw GameMode2B		; 2B -
dw GameMode2C		; 2C -
dw GameMode2D		; 2D -
dw GameMode2E		; 2E -
dw GameMode2F		; 2F -
dw GameMode30		; 30 -
dw GameMode31		; 31 -
dw GameMode32		; 32 -
dw GameMode33		; 33 -
dw GameMode34		; 34 -
dw GameMode35		; 35 -
dw GameMode36		; 36 -
dw GameMode37		; 37 -


GameMode2A:		;
GameMode2B:		;
GameMode2C:		;
GameMode2D:		;
GameMode2E:		;
GameMode2F:		;
GameMode30:		;
GameMode31:		;
GameMode32:		;
GameMode33:		;
GameMode34:		;
GameMode35:		;
GameMode36:		;
GameMode37:		;
RTS

EndCode:

print "Freespace used: ",bytes," bytes."
