;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Fireball Control
;By Scepile3
;Control fireball's virtical movement with the up and down arrows.
;
;Original code from:
; LR Hook - Version 1.1
; By Smallhacker
; 
; Disables L/R and prepares them to be used for other stuff
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;CHANGE THIS ADDRESS TO A FREE SECTION OF THE ROM!
!freeSpace = $0FEF90

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Disable L/R scrolling
org $00CDF6
    BRA lrSkip
org $0660    
org $00CE49
lrSkip:

;Hijack the status bar routine
org $008F49
	JSL NewRoutine

org $34B64
%RATS_start(0)

NewRoutine:
LDA $15
CMP #$04
BEQ MoveDown
LDA $15
CMP #$08
BEQ MoveUp
LDA #$FC
STA $1745
LDA #$FC
STA $1746
BRA Return
MoveUp:
LDA #$DF
STA $1745
LDA #$DF
STA $1746
BRA Return
MoveDown:
LDA #$1A
STA $1745
LDA #$1A
STA $1746
BRA Return

Return:
	LDA $0DBE
	INC A 
    RTL

%RATS_end(0)