;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Floating Patch, made by Leod
;This Patch will make Mario slowly Float down after each Jump or if hes just falling
;To fall normal, hold Down. If you release down again, he will start floating again.
;If you don't uncomment the BRA Return later down, Mario will also show the two Burned Frames while floating down.
;That's made for if you want some floating animation, like fluttering Wings or something.
;Please tell ma if there are any Bugs, and if anyone knows how to make the Frames code shorter, tell me.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!freeSpace = $108196
!freeram = $662

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $008F49
	JSL Routine

org !freeSpace
%RATS_start(0)

Routine:
    LDA $15    
    AND #$04
    BEQ buttonDown
    BRA Return

buttonDown:
	LDA $77		;Check if in Air
	CMP #$00		;Same
	BEQ Pressy		;If yes, GoBranch
	CMP #$02
	BEQ Pressy
	CMP #$01
	BEQ Pressy

    BRA Return    	;If not, GoNotBranch

Pressy:
	LDA $7D		;Check if falling
	CMP #$80		;Same
	BCC MahGod		;If yes, MahGod
	BRA Return  	;If not, End
MahGod:
	LDA #$08
	STA $7D
	LDA !freeram
	BEQ Frame1
	BRA Frame2

Frame1:
	LDA #$30
	STA $13E0
	BRA Return	

Frame2:
	LDA #$31
	STA $13E0
	BRA Return

Return:
	LDA $0DBE
	INC A 
    RTL

%RATS_end(0)