HEADER
LOROM

!Freespace = $868280	;It is recommended that the space is below bank $40

; ===================================================================
; Repoint $7F8000 to Freespace if any patch, sprite, block or anything else uses it. ;
; ===================================================================

; Actual code for jumping: Freespace + 8 = $868288

; =======================================================
;  Cancel out RAM routine creation
; =======================================================

ORG $808027
	SEP #$30
	BRA +

ORG $808052
+	

; =======================================================;  Repoint every RAM routine JSL to avoid crashes
; =======================================================

ORG $808642
JSL Unroll

ORG $8094FD
JSL Unroll

ORG $8095AB
JSL Unroll

ORG $809632
JSL Unroll

ORG $809759
JSL Unroll

ORG $809870
JSL Unroll

ORG $809888
JSL Unroll

ORG $809A6F
JSL Unroll

ORG $809C9F
JSL Unroll

ORG $80A1C3
JSL Unroll

ORG $80A295
JSL Unroll

ORG $8086DA
JSL Unroll_OAM_0391

ORG !Freespace
reset bytes
db "STAR"
dw END-Unroll-$01
dw END-Unroll-$01^$FFFF
Unroll:
		PHD
		PEA $0200
		PLD

		LDA #$F0
		STA $01
		STA $05
		STA $09
		STA $0D
		STA $11
		STA $15
		STA $19
		STA $1D
		STA $21
		STA $25
		STA $29
		STA $2D
		STA $31
		STA $35
		STA $39
		STA $3D
		STA $41
		STA $45
		STA $49
		STA $4D
		STA $51
		STA $55
		STA $59
		STA $5D
		STA $61
		STA $65
		STA $69
		STA $6D
		STA $71
		STA $75
		STA $79
		STA $7D
		STA $81
		STA $85
		STA $89
		STA $8D
		STA $91
		STA $95
		STA $99
		STA $9D
		STA $A1
		STA $A5
		STA $A9
		STA $AD
		STA $B1
		STA $B5
		STA $B9
		STA $BD
		STA $C1
		STA $C5
		STA $C9
		STA $CD
		STA $D1
		STA $D5
		STA $D9
		STA $DD
		STA $E1
		STA $E5
		STA $E9
		STA $ED
		STA $F1
		STA $F5
		STA $F9
		STA $FD

		PEA $0300
		PLD

		LDA #$F0
		STA $01
		STA $05
		STA $09
		STA $0D
		STA $11
		STA $15
		STA $19
		STA $1D
		STA $21
		STA $25
		STA $29
		STA $2D
		STA $31
		STA $35
		STA $39
		STA $3D
		STA $41
		STA $45
		STA $49
		STA $4D
		STA $51
		STA $55
		STA $59
		STA $5D
		STA $61
		STA $65
		STA $69
		STA $6D
		STA $71
		STA $75
		STA $79
		STA $7D
		STA $81
		STA $85
		STA $89
		STA $8D
		PLD

.OAM_0391	PHD		;it can't be helped but re-do the direct page register wrapper
		PEA $0300	;to fix the Ludwig battle.
		PLD
		STA $91
		STA $95
		STA $99
		STA $9D
		STA $A1
		STA $A5
		STA $A9
		STA $AD
		STA $B1
		STA $B5
		STA $B9
		STA $BD
		STA $C1
		STA $C5
		STA $C9
		STA $CD
		STA $D1
		STA $D5
		STA $D9
		STA $DD
		STA $E1
		STA $E5
		STA $E9
		STA $ED
		STA $F1
		STA $F5
		STA $F9
		STA $FD
		PLD
		RTL

END:
print bytes