header
lorom

;-------------;
; Defines etc ;
;-------------;
	
!FreeSpace = $17C717 ; POINT TO FREESPACE!
!FreeRAMUno = $1560 ; It doesn't need to be free, but make sure it's not used during the intro code. The default isn't used.
!TimeToWait = $10 ; Time to show 'Nintendo' (01 is the shortest time, 00 the longest.)
!FadeInSpeed = $07 ; Has to be a power of 2 minus 1. (01, 03, 07, 0F, 1F, 3F, 7F, FF). The higher the number, the slower it fades in.
!FadeOutSpeed = $03 ; ^ see description
!TimeToBlank = $10 ; Time to remain blank after the logo showed (before the 'Nintendo Presents')

;-------------;
; Hijacks etc ;
;-------------;

org $009394
JML Main

org $00940F
JML NotSoMode1

;-------------;
; Custom etc  ;
;-------------;

org !FreeSpace
db "STAR"
dw End-Main-$01
dw End-Main-$01^$FFFF

Main:
PHK
PEA.w SetUpScreen-1
PEA $84CE
JML $008A79

SetUpScreen:
PHK
PEA.w CODE_00A993-1
PEA $84CE
JML $00A993

CODE_00A993:
LDA !FreeRAMUno
CMP #$01
BEQ DoDiz
LDA #$80
STA $2115
STZ $2116
STZ $2117
LDX #$06

GraphicsLoop:
LDA.l DMATable,x
STA $4300,x
DEX
BPL GraphicsLoop
LDA #$01
STA $420B
REP #$10
LDY.w #NintendoTilemap
STY $00
LDA.b #NintendoTilemap/65536
STA $02
SEP #$20
PHK
PEA.w ReturnSauce-1
PEA $84CE
JML $00871E

ReturnSauce:
REP #$20
LDX.b #PalEnd-PalBegin-$02

PaletteZeroLoop:
LDA.l Pal0Table,x
STA $0705,x
DEX
DEX
BPL PaletteZeroLoop
SEP #$20
LDA #!TimeToWait
STA $1DF5
REP #$20
LDA #$2103
STA $4330
LDA.w #HDMA
STA $4332
LDY.b #HDMA/65536
STY $4334
SEP #$20
LDA #$08
TSB $0D9F
PHK
PEA.w Wutsauce-1
PEA $84CE
JML $00922F

Wutsauce:
LDX #$11
JML $0093E8

DoDiz:
JML $00939A

PalBegin: ; do not remove this label

Pal0Table:
dw $0C14,$1C97,$3158,$1419,$4E3A,$1C9A,$28FB,$4A5D,$6F3F,$7FFF ; Colours 1-A. You can modify it, if you want, or even add more slots.

PalEnd: ; do not remove this label

NintendoTilemap:
db $21,$42,$00 : db TopLineEnd-TopLineBeg-$01
TopLineBeg:
db $01,$20
db $02,$20
db $03,$20
db $04,$20
db $05,$20
db $06,$20
db $07,$20
db $08,$20
db $09,$20
db $0A,$20
db $0B,$20
db $0C,$20
db $0D,$20
db $0E,$20
db $0F,$20
db $70,$20
db $71,$20
db $72,$20
db $73,$20
db $74,$20
db $75,$20
db $76,$20
db $77,$20
db $78,$20
db $79,$20
db $7A,$20
db $7B,$20
db $7C,$20
db $7D,$20
db $7E,$20
db $7F,$20
TopLineEnd:

db $21,$61,$00 : db NotTopLineEnd-NotTopLineBeg-$01
NotTopLineBeg:
db $10,$20
db $11,$20
db $12,$20
db $13,$20
db $14,$20
db $15,$20
db $16,$20
db $17,$20
db $18,$20
db $19,$20
db $1A,$20
db $1B,$20
db $1C,$20
db $1D,$20
db $1E,$20
db $1F,$20
db $80,$20
db $81,$20
db $82,$20
db $83,$20
db $84,$20
db $85,$20
db $86,$20
db $87,$20
db $88,$20
db $89,$20
db $8A,$20
db $8B,$20
db $8C,$20
db $8D,$20
db $8E,$20
db $8F,$20
NotTopLineEnd:

db $21,$81,$00 : db NotSoTopLineEnd-NotSoTopLineBeg-$01
NotSoTopLineBeg:
db $20,$20
db $21,$20
db $22,$20
db $23,$20
db $24,$20
db $25,$20
db $26,$20
db $27,$20
db $28,$20
db $29,$20
db $2A,$20
db $2B,$20
db $2C,$20
db $2D,$20
db $2E,$20
db $2F,$20
db $90,$20
db $91,$20
db $92,$20
db $93,$20
db $94,$20
db $95,$20
db $96,$20
db $97,$20
db $98,$20
db $99,$20
db $9A,$20
db $9B,$20
db $9C,$20
db $9D,$20
db $9E,$20
db $9F,$20
NotSoTopLineEnd:

db $21,$A1,$00 : db MehNotTopLineEnd-MehNotTopLineBeg-$01
MehNotTopLineBeg:
db $30,$20
db $31,$20
db $32,$20
db $33,$20
db $34,$20
db $35,$20
db $36,$20
db $37,$20
db $38,$20
db $39,$20
db $3A,$20
db $3B,$20
db $3C,$20
db $3D,$20
db $3E,$20
db $3F,$20
db $A0,$20
db $A1,$20
db $A2,$20
db $A3,$20
db $A4,$20
db $A5,$20
db $A6,$20
db $A7,$20
db $A8,$20
db $A9,$20
db $AA,$20
db $AB,$20
db $AC,$20
db $AD,$20
db $AE,$20
db $AF,$20
MehNotTopLineEnd:

db $21,$C1,$00 : db NotBottomLineEnd-NotBottomLineBeg-$01
NotBottomLineBeg:
db $40,$20
db $41,$20
db $42,$20
db $43,$20
db $44,$20
db $45,$20
db $46,$20
db $47,$20
db $48,$20
db $49,$20
db $4A,$20
db $4B,$20
db $4C,$20
db $4D,$20
db $4E,$20
db $4F,$20
db $B0,$20
db $B1,$20
db $B2,$20
db $B3,$20
db $B4,$20
db $B5,$20
db $B6,$20
db $B7,$20
db $B8,$20
db $B9,$20
db $BA,$20
db $BB,$20
db $BC,$20
db $BD,$20
db $BE,$20
db $BF,$20
NotBottomLineEnd:

db $21,$E1,$00 : db NotTopLineEndWut-NotTopLineBegWut-$01
NotTopLineBegWut:
db $50,$20
db $51,$20
db $52,$20
db $53,$20
db $54,$20
db $55,$20
db $56,$20
db $57,$20
db $58,$20
db $59,$20
db $5A,$20
db $5B,$20
db $5C,$20
db $5D,$20
db $5E,$20
db $5F,$20
db $C0,$20
db $C1,$20
db $C2,$20
db $C3,$20
db $C4,$20
db $C5,$20
db $C6,$20
db $C7,$20
db $C8,$20
db $C9,$20
db $CA,$20
db $CB,$20
db $CC,$20
db $CD,$20
db $CE,$20
db $CF,$20
NotTopLineEndWut:

db $22,$01,$00 : db BottomLineEnd-BottomLineBeg-$01
BottomLineBeg:
db $60,$20
db $61,$20
db $62,$20
db $63,$20
db $64,$20
db $65,$20
db $66,$20
db $67,$20
db $68,$20
db $69,$20
db $6A,$20
db $6B,$20
db $6C,$20
db $6D,$20
db $6E,$20
db $6F,$20
db $D0,$20
db $D1,$20
db $D2,$20
db $D3,$20
db $D4,$20
db $D5,$20
db $D6,$20
db $D7,$20
db $D8,$20
db $D9,$20
db $DA,$20
db $DB,$20
db $DC,$20
db $DD,$20
db $DE,$20
db $DF,$20
BottomLineEnd:
db $FF

HDMA:
db $02 : dw $0000,$294A
db $01 : dw $0000,$2D6B
db $01 : dw $0000,$318C
db $01 : dw $0000,$35AD
db $01 : dw $0000,$39CE
db $01 : dw $0000,$3DEF
db $01 : dw $0000,$4210
db $01 : dw $0000,$4631
db $02 : dw $0000,$4A52
db $02 : dw $0000,$4E73
db $02 : dw $0000,$5294
db $03 : dw $0000,$56B5
db $03 : dw $0000,$5AD6
db $03 : dw $0000,$5EF7
db $03 : dw $0000,$6318
db $04 : dw $0000,$6739
db $04 : dw $0000,$6B5A
db $04 : dw $0000,$6F7B
db $04 : dw $0000,$739C
db $04 : dw $0000,$77BD
db $04 : dw $0000,$7BDE
db $7A : dw $0000,$7FFF
db $04 : dw $0000,$7BDE
db $04 : dw $0000,$77BD
db $04 : dw $0000,$739C
db $04 : dw $0000,$6F7B
db $04 : dw $0000,$6B5A
db $04 : dw $0000,$6739
db $03 : dw $0000,$6318
db $03 : dw $0000,$5EF7
db $03 : dw $0000,$5AD6
db $03 : dw $0000,$56B5
db $02 : dw $0000,$5294
db $02 : dw $0000,$4E73
db $02 : dw $0000,$4A52
db $01 : dw $0000,$4631
db $01 : dw $0000,$4210
db $01 : dw $0000,$3DEF
db $01 : dw $0000,$39CE
db $01 : dw $0000,$35AD
db $01 : dw $0000,$318C
db $01 : dw $0000,$2D6B
db $01 : dw $0000,$294A
db $00

DMATable:
db $01,$18
dl GraphicsBegin
dw GraphicsEnd-GraphicsBegin

HehSauce:
LDA $0DAE
BEQ DontKeepDeccing
LDA $13
AND #!FadeOutSpeed
BNE Return00941A
DEC $0DAE
BRA Return00941A

DontKeepDeccing:
STZ $0D9F
LDA $1DF5
CMP.b #!TimeToBlank^$FF
BEQ GoBach
DEC $1DF5
BRA Return00941A

GoBach:
LDA #$01
STA !FreeRAMUno
STZ $0100
BRA Return00941A

NotSoMode1:
LDA !FreeRAMUno
CMP #$01
BEQ DoDad
CMP #$02
BEQ HehSauce
LDA $0DAE
CMP #$0F
BEQ MaxBrig
LDA $13
AND #!FadeInSpeed
BNE Return00941A
INC $0DAE
BRA Return00941A

MaxBrig:
DEC $1DF5
BNE Return00941A
LDA #$02
STA !FreeRAMUno
BRA Return00941A

DoDad:
DEC $1DF5
BNE Return00941A
JML $009414

Return00941A:
JML $00941A

GraphicsBegin:
incbin Nintendo.bin
GraphicsEnd:

End: