;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Line-Guide "Acts Like" Fix, by imamelia
;
; This patch makes the line guide processing routine depend on the "acts like"
; setting of the Map16 tiles rather than the tile number.  This allows you to put
; line guide tiles anywhere on any Map16 page, as long as they act like the original
; tiles (or a tile set to act like one of the original tiles).
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

org $01D99C
autoclean JML LineGuideActFix

freecode
reset bytes

LineGuideActFix:
	XBA
	LDA $1693
	REP #$30
	ASL
	ADC $06F624
	STA $0D
	SEP #$20
	LDA $06F626
	STA $0F
	REP #$20
	LDA [$0D]
	SEP #$30
	STA $1693
	XBA
	CMP #$02
	BCS LineGuideActFix
	CMP #$00
	JML $81D9A6

print "Freespace used: ",bytes," bytes."
print "Next address: $",pc