header
lorom

!FreeSpace = $13F000
!Freeram = $87		;MUST BE CLEARED ON LEVEL LOAD

!Music = $0C
!Soundeffect = $23
!Soundbank = $1DF9

org $008E2D
JML TimerStop
NOP

org $01C078
JSL InitCode

org $0086C1		;end of controllerupdate
JSL NoController
NOP

org $01C0A7
JSL MainCode
;LDA $1594,x
;CMP #$08
;BEQ DontDieInAHole
RTS
DontDieInAHole:
JMP $C0E7

org $01C11F
NOP #4

org $01C0EF
BRA $08
NOP #8

;1686: 29
;190F: 46

org !FreeSpace
db "STAR"
dw CodeEnd-InitCode
dw CodeEnd-InitCode^$FFFF

InitCode:
PHA
LDA $7FAB10,x
;BNE .special
LDA $15F6,x
AND #$F1
ORA #$08
STA $15F6,x
LDA $166E,x
AND #$F1
ORA #$08
STA $166E,x
.special
LDA $14D4,x
XBA
LDA $D8,x
REP #$20
SEC
SBC #$0080
SEP #$20
STA $D8,x
XBA
STA $14D4,x
STZ $1594,x
PLA
SBC #$08
STA $C2,x
RTL

MainCode:
LDA $1594,x
JSL $0086DF

dw NoTouched
dw Above
dw CalcScore
dw WaitSecond		;$163E,x for waitsecond timer
dw Falling
dw WaitSecond
dw Jumping
dw FallTime
dw WaitSecond
dw StupidHop
dw Peace
dw TimeScore
dw Derrr

NoTouched:
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
CMP $94
BCS NotBlargh
SEP #$20
LDA $1338
INC $1594,x
INC $1594,x
STZ $7B
LDA $14D4,x
XBA
LDA $D8,x
REP #$20
SEC
SBC #$0010
CMP $96
BCC NotBlargh
SEP #$20
DEC $1594,x
NotBlargh:
SEP #$20
RTL

Above:
LDA $14D4,x
XBA
LDA $D8,x
REP #$20
SEC
SBC #$0010
CMP $96
BCS .NotDoneYet
SEP #$20
INC $1594,x
.NotDoneYet
SEP #$20
STZ $7B
RTL

CalcScore:
LDA #$80
STA $1DFB
INC $1594,x
LDA #$40
STA $163E,x		;ex: 00F0
LDA $1534,x
XBA
LDA $1528,x
REP #$20
SEC
SBC #$0080		;0170
SEC
SBC $96
LSR #4		;divide by 0x10
SEP #$20
JSL $02ACE5
JSL $00FA80	;clear enemies
LDA #$01
STA !Freeram
RTL

WaitSecond:
LDA $1594,x
CMP #$08
BEQ .nopos
LDA #$20
STA $13E0
.nopos
LDA #$01
STA $76
STZ $7B
STZ $7D
STZ $77
STZ $1DFA
STZ $1DFC
STZ $1DF9
LDA $163E,x
BNE .notzeroyet
LDA #$40
STA $163E,x
INC $1594,x
LDA $1594,x
CMP #$04
BNE .notzeroyet
LDA #!Soundeffect
STA !Soundbank
.notzeroyet
RTL

Falling:
LDA #$20
STA $13E0
LDA #$01
STA $76
STZ $7B
STZ $7D
LDA $1534,x
XBA
LDA $1528,x
REP #$20
DEC
DEC
DEC
CMP $96
BEQ .marioground
INC $96
.marioground
SEC
SBC #$0080
STA $00
SEP #$20
LDA $14D4,x
XBA
LDA $D8,x
REP #$20
CMP $00
BCS .lolground
INC
SEP #$20
STA $D8,x
XBA
STA $14D4,x
RTL
.lolground
SEP #$20
INC $1594,x
LDA #$10
STA $163E,x
RTL

Jumping:
LDA #!Music
STA $1DFB
LDA #$FF
STA $0DDA
LDA #$A0
STA $7D
STZ $7B
INC $1594,x
LDA #$01
STA $1DFA
INC
STA $163E,x
RTL

PoseTable:
db $24,$0B

FallTime:
JSR Poser
LDA #$01
STA $76
STZ $7B
REP #$20
INC $94
INC $94
SEP #$20
LDA $77
BIT #$04
BEQ .zomg
INC $1594,x
LDA #$40
STA $163E,x
.zomg
RTL

Poser:
LDA $187A
BNE Yoshiiiii
PHB
PHK
PLB
LDA $7D
BEQ StandIt
ROL #2
AND #$01
TAY
LDA PoseTable,y
PLB
STA $13E0
RTS
StandIt:
STZ $13E0
PLB
RTS
Yoshiiiii:
LDA #$20
STA $13E0
RTS

StupidHop:
JSR Poser
STZ $7B
LDA #$01
STA $76
LDA $77
BIT #$04
BEQ .end
LDA $163E,x
BNE .jumpers
INC $1594,x
LDA #$40
STA $163E,x
RTL
.jumpers
LDA #$B0
STA $7D
LDA #$01
STA $1DFA
.end
RTL

Peace:
LDA #$26                	; \ Mario's image = Peace Sign, or 
LDY $187A         		;  | 
BEQ CODE_00CA3A           	;  | 
LDA #$14                	;  | Mario's image = Peace Sign on Yoshi 
CODE_00CA3A:			;  |
STA $13E0          		; /  YEAAAAH ALL.LOG RIP
LDA $163E,x
BNE .end
INC $1594,x
INC !Freeram
LDA #$11
STA $1DFC
LDA #$A0
STA $163E,x
.end
RTL

TimeScore:
LDA $0F31
BEQ .tens
DEC $0F31
REP #$20
LDA $0F34
CLC
ADC #$01F4
STA $0F34
SEP #$20
BCC .end
INC $0F36
RTL
.tens
LDA $0F32
BEQ .ones
DEC $0F32
REP #$20
LDA $0F34
CLC
ADC #$0032
STA $0F34
SEP #$20
BCC .end
INC $0F36
RTL
.ones
LDA $0F33
BEQ .endofitall
DEC $0F33
REP #$20
LDA $0F34
CLC
ADC #$0005
STA $0F34
SEP #$20
BCC .end
INC $0F36
RTL
.endofitall
INC $1594,x
LDA #$12
STA $1DFC
.end
RTL

Derrr:
LDA $163E,x
BNE .end
LDA $0DD5
BEQ $02
BPL $19
LDA #$80
BRA $00
LDA #$01
STA $13CE
STA $0DD5
INC $1DE9
LDA #$0B
STA $0100
RTL
LDA $0DD5
BEQ $02
BPL $19
LDA #$80
BRA $00
LDA #$01
INC
STA $13CE
STA $0DD5
INC $1DE9
LDA #$0B
STA $0100
.end
RTL

TimerStop:
LDA #$28
STA $0F30
LDA !Freeram
BNE .awaaaay
JML $008E32
.awaaaay
JML $008E6F

NoController:
LDA $0DA8,x
STA $18
LDA !Freeram
BNE .eeef
.eeed
RTL
.eeef
STZ $15
STZ $16
STZ $17
STZ $18
DEC
BEQ .eeed
STA $15
RTL


CodeEnd: