header
lorom

;------------------------------------------------------------------
; Settings, modify them if you like.
;------------------------------------------------------------------

!GFX_FILE = #$00		;gfx/exgfx file to use for logo (00-FF)
!SFX = #$01			;sound effect for logo
!PAL = #$00			;palette/gfx page: 00 = default, next palette is 02,04,06 etc...

!CODE_OFFSET = $1ACE00		;offset to use for graphics routine, make sure that it isn't used! (SNES format)

;------------------------------------------------------------------

org $00939a
 LDY #$3C		
 LDX #$0F		;amount of entries for properties below 

LoadTiles: 
 JML nintendologo

org $0093B4
 DEY
 DEY
 DEY
 DEY
 DEX
 BPL LoadTiles		;
 LDA #$AA		; \ Tilesize (8x8 or 16x16) for tiles
 STA $0403		;  |
 STA $0402		;  |
 STA $0401		;  |
 STA $0400		; /
 NOP

org $00A9CD
 db !GFX_FILE

;-------------------------;
;graphics routine for logo;
;-------------------------;

org !CODE_OFFSET

!CodeSize = End-xlogo

db "STAR"        ;\
dw !CodeSize-$01
dw !CodeSize-$01^$FFFF

xlogo:
db 	$60,$70,$80,$90,$60,$70,$80,$90,$60,$70,$80,$90,$60,$70,$80,$90

ylogo:
db 	$50,$50,$50,$50,$60,$60,$60,$60,$70,$70,$70,$70,$80,$80,$80,$80

tlogo:	
db	$02,$04,$06,$08,$22,$24,$26,$28,$42,$44,$46,$48,$62,$64,$66,$68		;tilemap

nintendologo:
LDA xlogo,x		;xpos
STA $0200,y

LDA ylogo,x		;ypos
STA $0201,y

LDA tlogo,x		;tilemap
STA $0202,y

flip:
LDA #$30		;properties
ora !PAL		;add palette settings              
STA $0203,y

LDA #$01     		;sfx     
STA $1DFC  
LDA #$40     		;time till fadeout
STA $1DF5  
JML $0093B4		;jump back

End: