;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Nintendo Present Logo HDMA v1.2
;; by Level ASMer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HEADER
LOROM

org $0093C0
autoclean	JML MAIN
		NOP

freecode
MAIN:		REP #$20		; 16 bit A

		PHK
		PLY

		LDA #$3200 		; $43X0 = 00
		STA $4330 		; $43x1 = 32

		LDA #RED		; get pointer to red color table
		STA $4332		; store it to low and high byte pointer
		STY $4334		; store to bank pointer byte

		LDA #$3200 		; $43X0 = 00
		STA $4340 		; $43x1 = 32

		LDA #GREEN		; get pointer to green color table
		STA $4342		; store it to low and high byte pointer
		STY $4344		; store to bank pointer byte

		LDA #$3200 		; $43X0 = 00
		STA $4350 		; $43x1 = 32

		LDA #BLUE		; get pointer to blue color table
		STA $4352		; store it to low and high byte pointer
		STY $4354		; store to bank pointer byte

		SEP #$20		; 8 bit A

		LDA #$38		; Enable HDMA on channels 3, 4 and 5
		TSB $0D9F

		LDA #$01		; Play SFX.
		STA $1DFC
		JML $0093C5

RED:
db $00

GREEN:
db $00

BLUE:
db $57,$00
db $02,$80
db $02,$81
db $02,$82
db $02,$83
db $02,$84
db $02,$85
db $02,$86
db $02,$87
db $02,$88
db $02,$89
db $02,$8A
db $02,$8B
db $02,$8C
db $02,$8D
db $02,$8E
db $02,$8F
db $02,$8E
db $02,$8D
db $02,$8C
db $02,$8B
db $02,$8A
db $02,$89
db $02,$88
db $02,$87
db $02,$86
db $02,$85
db $02,$84
db $02,$83
db $02,$82
db $02,$81
db $02,$80
db $01,$00
db $00