;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Raccoon Mario and Cape Mario					;;
;;Simultaneous in the same ROM					;;
;;Patch created by Chdata/Fakescaper				;;
;;Based off of Neosz's "MUCH Better Raccoon Patch"		;;
;;								;;
;;Hex.zip just contains a patch with the unnecessary		;;
;;hex edits that were in the "MUCH Better" Raccoon Patch	;;
;;that overwrote stuff in SMW's compressed gfx data		;;
;;and wrote completely useless junk into an empty area		;;
;;in the rom							;;
;;DO NOT PATCH ANYTHING INCLUDED IN HEX.ZIP			;;
;;ALSO DO NOT PATCH THIS AND THE "MUCH better Raccoon Patch"	;;
;;TO THE SAME ROM!!!						;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro	BNK()
	PHB : PHK : PLB
endmacro

Header
Lorom

!ram = $87	;If zero, cape mario, if not, raccoon mario
!freespace = $168000

{org $D676}	;Change flight time for raccoon
JML FlighTime
NOP

{org $D80C}	;Some other mysterious thing that gets NOP'd out
JML MysteriousNOP
NOP		;This makes it so that if you're raccoon, you can't go into bungey flight and dive/etc

{org $D904}	;Make us use $16 instead of $15 if raccoon
JML Press16s

{org $D908}	;Give us Raccoon SFX if raccoon
JML RaccoonSFX
NOP

{org $D911}	;Dunno what this is for
JML FloatSpeedR
NOP

{org $D948}	;Mysterious table change 1 for raccoon
JML MysterySlyCooper

{org $E3B6}	;Caped Mario head tilemap for Raccoon. This was actually kinda easy to do
JML TileMapRacApe
NOP

{org $E412}	;Explanation
JML MoreRandomRamSpecificHexEdits
NOP ;E

{org $E428}	;Coolstuff
JML E
NOP

org !freespace	;Freespace
db "STAR"
dw End-Start-$01
dw End-Start-$01^$FFFF
Start:

RaccoonSFX:
LDA !ram
BNE RaccooNow
LDA #$10
STA $14A5
BRA JumpBack
RaccooNow:
LDA #$08
STA $14A5
LDA $1DFA
CMP #$01
BEQ JumpBack
LDA #$04
STA $1DFC
JumpBack:
JML $00D90D

Press16s:
LDA !ram
BNE RaccooNow1
LDA $15,x
BPL CODE_00D924
JMP RaccoonSFX
CODE_00D924:
JML $00D924
RaccooNow1:
LDA $16,x
BPL CODE_00D924
JMP RaccoonSFX

FlighTime:
LDA !ram
BNE RaccooNow2
LDA #$50
STA $149F
BRA GoBackForFlighTime
RaccooNow2:
LDA #$B0
STA $149F
GoBackForFlighTime:
JML $00D67B

MysterySlyCooper:
PHA
LDA !ram
BNE RaccooNow3
PLA
CLC
ADC $D7A5,y
JML $00D94C
RaccooNow3:
PLA
%BNK()
CLC
ADC.w DATA_00D7A5Raccoon,y
PLB
JML $00D94C

FloatSpeedR:
PHA
LDA !ram
BNE RaccooNow4
PLA
LDX.w $D7B9,y
BPL CODE_00D9242
JML $00D916
CODE_00D9242PLB:
PLB
CODE_00D9242:
JML $00D924
RaccooNow4:
PLA
%BNK()
LDX.w DATA_00D7B9Raccoon,y
BPL CODE_00D9242PLB
CMP.w DATA_00D7B9Raccoon,y
BCC CODE_00D9242PLB
LDA.w DATA_00D7B9Raccoon,y
CMP $7D
PLB
JML $00D920

MysteriousNOP:
LDA.w $149F
PHA
LDA !ram
BNE RaccooNow5
PLA
BNE CODE_00D814
JML $00D811
CODE_00D814:
JML $00D814
RaccooNow5:
PLA
JML $00D811

TileMapRacApe:
LDA !ram
BNE RaccooNow6
LDA.w $E00C,y
STA $0A
JML $00E3BB
RaccooNow6:
%BNK()
LDA.w DATA_00E00CRaccoon,y
STA $0A
LDA.w DATA_00E0CCRaccoon,y
STA $0B
PLB
JML $00E3C0

MoreRandomRamSpecificHexEdits:
LDA !ram
BNE RaccooNow8
LDA.w $E1D8,x
STA $0E
JML $00E417
RaccooNow8:
%BNK()
LDA.w DATA_00E1D8Raccoon,x
STA $0E
PLB
JML $00E417

E:
LDA !ram
BNE RaccooNow9
LDA.w $E23A,y
STA $0C
JML $00E42D
RaccooNow9:
%BNK()
LDA.w DATA_00E23ARaccoon,y
STA $0C
LDA.w DATA_00E266Raccoon,y
PLB
JML $00E430

DATA_00D7A5Raccoon:			;00D7
db $06,$03,$04,$A0,$F4,$01,$03,$04	;a5,a6,a7,a8,a9,aa,ab,ac
db $05,$06				;ad,ae
DATA_00D7AFMISC:			;00D7
db $40,$40,$20,$40,$40,$40,$40,$40	;AF,B0,B1,B2,B3,B4,B5,B6
db $40,$40				;B7,B8
DATA_00D7B9Raccoon:			;00D7
db $08,$E0,$E0,$02,$03,$03,$04,$03	;b9,ba,bb,bc,bd,be,bf,c0
db $02,$00,$01,$00,$00,$00,$00		;c1,c2,c3,c4,c5,c6,c7
DATA_00D7C8MISC:			;00D7
db $01,$10,$30,$30,$38,$38,$40		;C8,C9,CA,CB,CC,CD,CE
CapeSpeedMISC:				;00D7
db $FF,$01,$01,$FF,$FF			;CF,D0,D1,D2,D3
DATA_00D7D4MISC:			;00D7
db $01,$06,$03,$01,$00			;D4,D5,D6,D7,D8
DATA_00D7D9MISC:			;00D7
db $00,$00,$00,$F8,$F8,$F8,$F4,$F0	;D9,DA,DB,DC,DD,DE,DF,E0
db $C8,$02,$01				;E1,E2,E3
DATA_00E00CRaccoon:			;00E0
db $50,$50,$50,$09,$50,$50,$50,$50	;0c,0d,0e,0f,10,11,12,13
db $50,$50,$09,$2B,$50,$2D,$50,$D5	;14.15.16.17.18.19.1a.1b
db $2E,$C4,$C4,$C4,$D6,$B6,$50,$50	;1c,1d,1e,1f,20,21,22,23
db $50,$50,$50,$50,$50,$C5,$D7,$2A	;24.25.26.27.28.29.2a.2b
db $E0,$50,$D5,$29,$2C,$B6,$D6,$28	;2c,2d,2e,2f,30,31,32,33
db $E0,$E0,$C5,$C5,$C5,$C5,$C5,$C5	;34.35.36.37.38.39.3a.3b
db $5C,$5C,$50,$5A,$B6,$50,$28,$28	;3c,3d,3e,3f,40,41,42,43
db $C5,$D7,$28,$70,$C5,$70,$1C,$93	;44.45.46.47.48.49.4a.4b
db $C5,$C5,$0B,$85,$90,$84,$70,$70	;4c,4d,4e,4f,50,51,52,53
db $70,$A0,$70,$70,$70,$70,$70,$70	;54.55.56.57.58.59.5a.5b
db $A0,$74,$70,$80,$70,$84,$17,$A4	;5c,5d,5e,5f,60,61,62,63
db $A4,$A4,$B3,$B0,$70,$70,$70,$70	;64.65.66.67.68.69.6a.6b
db $70,$70,$70,$E2,$72,$0F,$61,$70	;6c,6d,6e,6f,70,71,72,73
db $63,$82,$C7,$90,$B3,$D4,$A5,$C0	;74.75.76.77.78.79.7a.7b
db $08,$54,$0C,$0E,$1B,$51,$49,$4A	;7c,7d,7e,7f,80,81,82,83
db $48,$4B,$4C,$5D,$5E,$5F,$E3,$90	;84.85.86.87.88.89.8a.8b
db $5F,$5F,$C5,$40,$40,$40,$51,$40	;8c,8d,8e,8f,90,91,92,93
db $40,$40,$40,$40,$40,$51,$42,$40	;94.95.96.97.98.99.9a.9b
db $43,$40,$45,$20,$52,$52,$52,$55	;9c,9d,9e,9f,a0,a1,a2,a3
db $54,$40,$40,$40,$40,$40,$40,$40	;a4.a5.a6.a7.a8.a9.aa.ab
db $67,$41,$76,$21,$40,$37,$44,$64	;ac,ad,ae,af,b0,b1,b2,b3
db $47,$55,$65,$53,$C0,$08,$64,$0C	;b4.b5.b6.b7.b8.b9.ba.bb
db $0E,$1B,$51,$08,$08,$77,$0A,$0C	;bc,bd,be,bf,c0,c1,c2,c3
db $0D,$0E,$4F,$75,$47,$4F,$4F,$C5	;c4.c5.c6.c7.c8.c9.ca.cb
DATA_00E0CCRaccoon:			;00E0
db $71,$60,$60,$19,$94,$96,$96,$A2	;cc,cd,ce,cf,d0,d1,d2,d3
db $97,$97,$18,$3B,$B4,$3D,$A7,$E5	;d4.d5.d6.d7.d8.d9.da.db
db $2F,$D3,$C3,$C3,$F6,$D0,$B1,$81	;dc,dd,de,df,e0,e1,e2,e3
db $B2,$86,$B4,$87,$A6,$D1,$F7,$3A	;e4.e5.e6.e7.e8.e9.ea.eb
db $F0,$F4,$F5,$39,$3C,$C6,$E6,$38	;ec,ed,ee,ef,f0,f1,f2,f3
db $F1,$F0,$C5,$C5,$C5,$C5,$C5,$C5	;f4.f5.f6.f7.f8.f9.fa.fb
db $6C,$4D,$71,$6A,$6B,$60,$38,$F1	;fc,fd,fe,ff,00,01,02,03 ;00E1
db $5B,$69,$F1,$F1,$4E,$E1,$1D,$A3	;04.05.06.07.08.09.0a.0b
db $C5,$C5,$1A,$95,$10,$07,$02,$01	;0c,0d,0e,0f,10,11,12,13
db $00,$02,$14,$13,$12,$30,$27,$26	;14.15.16.17.18.19.1a.1b
db $30,$03,$15,$04,$31,$07,$E7,$25	;1c,1d,1e,1f,20,21,22,23
db $24,$23,$62,$36,$33,$91,$34,$92	;24.25.26.27.28.29.2a.2b
db $35,$A1,$32,$F2,$73,$1F,$C0,$C1	;2c,2d,2e,2f,30,31,32,33
db $C2,$83,$D2,$10,$B7,$E4,$B5,$61	;34.35.36.37.38.39.3a.3b
db $0A,$55,$0D,$75,$77,$1E,$59,$59	;3c,3d,3e,3f,40,41,42,43
db $58,$02,$02,$6D,$6E,$6F,$F3,$68	;44.45.46.47.48.49.4a.4b
db $6F,$6F,$06,$02,$01,$00,$02,$14	;4c,4d,4e,4f,50,51,52,53
db $13,$12,$30,$27,$26,$30,$03,$15	;54.55.56.57.58.59.5a.5b
db $04,$31,$07,$E7,$25,$24,$23,$62	;5c,5d,5e,5f,60,61,62,63
db $36,$33,$91,$34,$92,$35,$A1,$32	;64.65.66.67.68.69.6a.6b
db $F2,$73,$1F,$C0,$C1,$C2,$83,$D2	;6c,6d,6e,6f,70,71,72,73
db $10,$B7,$E4,$B5,$21,$0A,$55,$0D	;74.75.76.77.78.79.7a.7b
db $75,$77,$1E,$59,$59,$58,$02,$02	;7c,7d,7e,7f,80,81,82,83
db $6D,$6E,$6F,$F3,$68,$6F,$6F,$06	;84.85.86.87.88.89.8a.8b
MarioPalIndexMISC:			;00E1
db $00,$40				;8C,8D
DATA_00E18EMISC:			;00E1
db $00,$00,$00,$00,$00,$00,$00,$00	;
db $00,$00,$00,$00,$00,$0D,$00,$10	;
db $13,$22,$25,$28,$00,$16,$00,$00	;
db $00,$00,$00,$00,$00,$08,$19,$1C	;
db $04,$1F,$10,$10,$00,$16,$10,$06	;
db $04,$08,$2B,$30,$35,$3A,$3F,$43	;
db $00,$00,$00,$00,$00,$00,$00,$00	;
db $16,$16,$00,$00,$08,$00,$00,$00	;
db $00,$00,$00,$10,$04,$00		;
DATA_00E1D4MISC:			;00E1
db $06					;D4
DATA_00E1D5MISC:			;00E1
db $00					;D5
DATA_00E1D6MISC:			;00E1
db $06					;D6
DATA_00E1D7MISC:			;00E1
db $00					;D7
DATA_00E1D8Raccoon:			;00E1
db $86,$02,$06,$03,$06,$01,$06,$CE	;d8,d9,da,db,dc,dd,de,df
db $06,$06,$0A,$00,$06,$2C,$06,$06	;e0,e1,e2,e3,e4,e5,e6,e7
db $44,$0E,$86,$2C,$06,$86,$2C,$0A	;e8,e9,ea,eb,ec,ed,ee,ef
db $86,$84,$08,$06,$0A,$02,$06,$AC	;f0,f1,f2,f3,f4,f5,f6,f7
db $10,$06,$CC,$10,$06,$AE,$10,$00	;f8,f9,fa,fb,fc,fd,fe,ff
db $8C,$14,$80,$2E,$00,$CA,$16,$91	;00,01,02,03,04,05,06,07 ;00E2
db $2F,$00,$8E,$18,$81,$30,$00,$EB	;08,09,0a,0b,0c,0d,0e,0f
db $1A,$90,$31,$04,$ED,$1C,$82,$06	;10,11,12,13,14,15,16,17
db $92,$1E				;18,19
DATA_00E21AMISC:			;00E2
db $84,$86,$88,$8A,$8C,$8E,$90,$90	;1A,1B,1C,1D,1E,1F,20,21
db $92,$94,$96,$98,$9A,$9C,$9E,$A0	;22,23,24,25,26,27,28,29
db $A2,$A4,$A6,$A8,$AA,$B0,$B6,$BC	;2A,2B,2C,2D,2E,2F,30,31
db $C2,$C8,$CE,$D4,$DA,$DE,$E2,$E2	;32,33,34,35,36,37,38,39
DATA_00E23ARaccoon:			;00E2
db $0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A	;3a,3b,3c,3d,3e,3f,40,41
db $0A,$0A,$0A,$0A,$44,$44,$44,$44	;42,43,44,45,46,47,48,49
db $22,$22,$22,$22,$0A,$0A,$0A,$0A	;4a,4b,4c,4d,4e,4f,50,51
db $22,$22,$22,$22,$0A,$0A,$0A,$0A	;52,53,54,55,56,57,58,59
db $AE,$AE,$AE,$AE,$22,$22,$22,$22	;5a,5b,5c,5d,5e,5f,60,61
db $22,$22,$22,$22			;62,63,64,65
DATA_00E266Raccoon:			;00E2
db $02,$02,$02,$02,$02,$02,$02,$02	;66,67,68,69,6a,6b,6c,6d
db $02,$02,$02,$02,$02,$02,$02,$02	;6e,6f,70,71,72,73,74,75
db $02,$02,$02,$02,$02,$02,$02,$02	;76,77,78,79,7a,7b,7c,7d
db $02,$02,$02,$02,$02,$02,$02,$02	;7e,7f,80,81,82,83,84,85
db $02,$02,$02,$02,$02,$02,$02,$02	;86,87,88,89,8a,8b,8c,8d
db $02,$02,$02,$02			;8e,8f,90,91
End:
print "I'm psychic, I knew that you would patch this."
print "-Chdata-"