header
lorom

; Default sprite memory setting.  If you're using No Sprite Tile Limits, you may want to set this to 10.
!SprMem = $00

macro EmptyL1(number)
rep <number> : dl $078000
endmacro

macro EmptyL2(number)
rep <number> : dl $FFE8EE
endmacro

macro EmptySP(number)
rep <number> : dw $8006
endmacro

macro ZeroBytes(number)
rep <number> : db $00
endmacro

org $05E000
%EmptyL1(512)		; repoint all Layer 1 pointers
%EmptyL2(512)		; repoint all Layer 2 pointers
%EmptySP(512)		; repoint all sprite pointers
%ZeroBytes(4096)		; clear all data in tables $05F000-$05FFFF

org $078000					;
db $00,$00,$00,$00,$00,$FF,!SprMem,$FF	; blank data for Layer 1 and sprites

org $068000		;
%ZeroBytes(9657)		; clear all level data from $068000-$06A5B8

org $06A600		;
%ZeroBytes(9060)		; clear all level data from $06A600-$06C963

org $06D000		;
%ZeroBytes(9529)		; clear all level data from $06D000-$06F538

org $078008		;
%ZeroBytes(229)		; clear all level data from $078008-$0780EC

org $078100		;
%ZeroBytes(8313)		; clear all level data from $078100-$07A178

org $07A600		;
%ZeroBytes(7206)		; clear all level data from $07A600-$07C225

org $07C300		;
%ZeroBytes(9327)		; clear all level data from $07A600-$07E76E


