	;;  STICKY GROUND   ;;
	;; by WhiteYoshiEgg ;;


; - What does this patch do?
;    This patch makes Mario unable to move
;    if he's touching the ground. He can only
;    move forward by jumping.

; - Why did you make this patch?
;    Lemonade requested it, and I decided to 
;    submit it to SMWC so everyone can use it.

; - Are there any side effects?
;    Mario will die in the title screen, since
;    he can't move. You will need to change the
;    title screen level or moves to fix this.

; - Do I need to give credit?
;    Nah. Most of the code is taken from another
;    patch anyway. If you really want to give
;    credit though, go ahead.



header
lorom

!FreeSpace = $1F8000 ; POINT THIS TO SOME FREE SPACE!
		     ; If your ROM is at least 1MB big
		     ; and you haven't applied any other
		     ; patches before, you don't need
		     ; to change this.


	



	org $00A2E2
	JSL Main

	org !FreeSpace

	db "STAR" 			;\
	dw MainEnd-MainStart 		; | Write RATS tag #1 to protect main code
	dw MainEnd-MainStart^#$FFFF 	;/

	MainStart:
	Main:
	PHA 				;\
	PHY 				; |
	PHX				; | Preserve stuff
	PHB 				;/
	LDA $77				;\
	AND #$04			; | If Mario is touching the ground...
	BEQ Return			;/
	STZ $7B				;   ...set his X speed to 0.
	Return:
	PLB 				;\
	PLX 				; | Recover stuff
	PLY 				; |
	PLA 				;/

	JSL $01808C 			; Code from original routine. Don't touch this!
	RTL
	MainEnd: