;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Seperate Death And Time Up Deaths ;;
;;	     	   by		     ;;
;;	      wiiqwertyuiop          ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;

!FreeSpace = $1280000	; freespace
!Pose = $3C		; mario's pose when time up
!Sound = $2A		;\ sound effect to play
!Bank = $1DFC		;/
!Music = $09		; Music to play when death
!Time = $34		; Time before warping to the OW

;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


header
lorom

org $00F606
JML TimeStart

org $00D108
JML Test

org !FreeSpace
db "STAR"
dw TimeUp-TimeStart-$01
dw TimeUp-TimeStart-$01^$FFFF

TimeStart:
LDA $0F31     	;\  
ORA $0F32     	; | If time is zero branch
ORA $0F33	; |
BEQ DeathTime	;/
LDA #$90	;\ Restore old code
STA $7D		;/
JML $00F60A

DeathTime:
LDA #!Sound	;\ Play sound
STA !Bank	;/
LDA #!Music	;\ Change music
STA $1DFB	;/ 
LDA #$FF	;\ change music some more
STA $0DDA	;/
STZ $140D	; No spinjumping
STZ $1407	; Cape status = 0
LDA #$FF	;\ Set lock sprites timer
STA $9D		;/
LDA #$09	;\ Mario death sequence
STA $71		;/
LDA #!Time	;\ Set timer
STA $1496	;/
RTL

Test:
LDA $1496	;\
CMP #$26	; | Old code
BCS Done	; |
STZ $7B		;/
LDA $0F31	;\
ORA $0F32	; | If time up death
ORA $0F33	; | branch
BEQ Done	;/
JML $00D10E

Done:
LDA $0F31	;\
ORA $0F32	; | If not time up death
ORA $0F33	; | branch
BNE NotTimed	;/
LDA #!Pose	;\ Set pose
STA $13E0	;/
NotTimed:
JML $00D11C

TimeUp: