!FREESPACE2	=	$188000

header
lorom

org $019F6B

db $BE,$42,$CC,$34,$00,$10	; Make shells move faster when kicked in order to...
				; fix the glitch where you can run into a shell...
				; and hurt yourself right after kicking it...

org $02A129

JSL $02ACE5	;\  Make melon seeds actually kill the sprite...
LDA #$02	; | on contact...
STA $14C8,x	;/  instead of turning them into coins.

org $00D9ED

BRA $00		; Yoshi can't press A to swim.

org $01B4D8

JSL FixSolidSprites

org $02963A

db $0A

org $00D0B6

JSR $DC2D	;\
JSR $D92E	; |
RTS		;/ Hack death routine to update Yoshi's position by speed.

org $01CA75				;\
					; |
NOP #4		; LDA #$FF STA $78	; |
					; | Fix weird glitch with brown chained platform.
org $01C9E3				; |
					; |
NOP #4		; JSL $00E2BD		;/

org $029501

NOP #3

org $01E1C8	; Hijack keyhole sprite routine

	JSL Keyhole_Fix
	RTS

org $01C35F

db $EC		; Change berry sprite graphic tile.

org $029616

	JSL DisableCapeTurnBlock

org $009E35

JSL FixOverworldYoshi	;Fix initial overworld loading
NOP

org $0485CA

JSL FixOverworldYoshi2	;Fix initial overworld loading
NOP

org $019F92

db $EA,$EA,$EA	;Make all sprites invisible in the carried state.

org $00FEB1	;The number of fireballs allowed will be 9 minus this number, $00 will allow 9, and you can actually...

db $04		;Allow 10 fireballs at once!!!

org $029FF9

BRA $04		; Make melon seeds disappear when they hit the ground

org $029FD4

db $01		; Lower gravity on melon seeds

org $02A03C	;"db $07"

dw $FFF6	;(The other stuff is just changing the pointer to the fireballs' OAM indexes. Thanks to Imamelia.)

org $02FFF6	;

db $90,$94,$98	;
db $9C,$A0,$A4	;
db $A8,$AC,$F8	;
db $FC		;

org $00CF3D

db $EA,$EA	; disable turning while spin jumping

org $00D107

db $6B	; RTL

org $00D11C

db $6B	; RTL

org $00DF1A

incbin tilefix.bin	; fix tile expansion for Yoshi.

org $00D645

db $60	; disable spin jump

org $00D718

db $00	; always run

org $00E00C

incbin Tilemap.bin	; Load player tilemap

org $00EA82

db $80	; disable water spin jumping

org $00EB79

db $A9,$01	; Make small Mario 16x32

org $01B4C0

db $A0,$01	; Make small Mario 16x32

org $03B67C

db $A9,$01	; Make small Mario 16x32

org $00EE69

db $EA,$EA	; "small" yoshi can break turn blocks by groundpounding

org $00F5B2

JSL HurtMain1
RTS

org $00F5B7

JSL HurtMain
RTL

org $00F606

JSL KillMain
RTL

org $01AA5C

db $80	; disable carrying with hands

org $01E5F7

JSL $81AA33

org $01E691

db $80	; disable springboard spinjumping

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org !FREESPACE2		; freespace

db "STAR"				;\
dw HurtEnd-HurtStart-$01		; |Write RATS tag #1 to protect main code
dw HurtEnd-HurtStart-$01^$FFFF		;/

HurtStart:
HurtMain:
	LDA $1497
	BNE HurtReturn
	LDA #$60
	STA $1497

	LDA #$13
	STA $1DFC	; Play Yoshi hurt noise.

	STZ !FREERAM13	; Reset cursor flag.
	STZ !FREERAM16	; Reset lock flag.
	STZ !FREERAM25	; Make Yoshi let go of item on his tongue.
	STZ $74		; No climbing.

	PHX
	LDA #$E0
	STA $7D		; Knock Yoshi up in the air a bit.
	LDA $76
	TAX
	LDA XKnock,x
	STA $7B
	PLX

	LDA !FREERAM27	; Yoshi's health.
	BEQ KillMain

	LDA #$05
	STA !FREERAM28	; How much health to decrement.

	LDA #$01
	STA $19
HurtReturn:
	RTL

XKnock:
db $20,$E0

KillMain:
	STZ !FREERAM3		; Remove item from Yoshi's mouth, if there is one.
	STZ !FREERAM13		; Reset cursor flag.
	STZ !FREERAM16		; Reset lock flag.
	LDA #$01
	STA $185C	; Make Yoshi fall through ground.

	LDA #$01
	STA !FREERAM35	; Death flag.

	STZ $15
	STZ $16
	STZ $17
	STZ $18		; Disable controls.

	LDA #$09
	STA $71

	LDA #$C0
	STA $9D

	LDA #$FF
	STA $0DDA
	LDA #$09
	STA $1DFB	; Death music.
	STZ $1411
	STZ $1412	; No camera movement.
	RTL

HurtMain1:
	STZ !FREERAM27
	BRA HurtMain

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

FixOverworldYoshi:
	LDA #$01
	STA $19		; Make Yoshi big on overworld.
	STZ !FREERAM3	; Yoshi has nothing in his mouth.
	STZ $0DC2
	RTL

FixOverworldYoshi2:
	LDA #$01
	STA $19		; Make Yoshi big on overworld.
	STZ !FREERAM3	; Yoshi has nothing in his mouth.

	LDA #$05
	STA !FREERAM27	; Initial health; 5 starbits.

	STZ !FREERAM1	; Reset # of keys.

	LDA #$03	;\
	STA $13F9	;/ Restore hijacked code.
	RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DisableCapeTurnBlock:
	PHA
	PHX
	PHY

	LDX #$20
TongueBlock_NoCapesLoop:
	LDA $1693
	CMP TurnQuestionBlock,x
	BEQ TongueBlock_MakeSolid		; Change acts like settings if cape can interact with block.

	DEX
	BPL TongueBlock_NoCapesLoop
	BRA TongueBlock_CheckSolid

TongueBlock_MakeSolid:
	LDA #$30
	STA $1693				; Act like tile 130.
TongueBlock_CheckSolid:
	PLY
	PLX
	PLA
	INC $07		;
	LDA [$05]	; Restore hijacked code.
	RTL

TurnQuestionBlock:
db $11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,$20
db $21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$6A,$6B,$6C
db $6D

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Keyhole_Fix:
	JSR CODE_01E23A

	LDA $167A,x
	ORA #$80
	STA $167A,x	; Don't use default interaction with player

	JSL $01A7DC
	BCC Keyhole_Return

	LDA !FREERAM1	; # of keys Yoshi has
	BEQ Keyhole_Return

	LDA $77
	AND #$04
	BEQ Keyhole_Return

	LDA $16
	AND #$08
	BEQ Keyhole_Return

	DEC !FREERAM1

	LDA #$30
	STA $1434               
	LDA #$10	;\ 		               
	STA $1DFB	;/ Standard keyhole music.
	INC $13FB		               
	INC $9D		; Lock sprite data.     
	LDA $14E0,x	; Store sprite X pos high..     
	STA $1437	; To keyhole's X pos high.
	LDA $E4,x 	; Store sprite X pos low ..      
	STA $1436	; To keyhole's X pos low.
	LDA $14D4,x	;\   
	STA $1439	; | Store Y low/high bytes to keyhole  
	LDA $D8,x       ; | low/high bytes.
	STA $1438	;/
	LDA #$30	;\  
	STA $154C,X	;/ Disable contact with sprite.
Keyhole_Return:
	RTL
;========
;Graphics
;========
CODE_01E23A:                      JSR.w GET_DRAW_INFO  ; Get sprite position relative to screen.   
CODE_01E23D:                      LDA $00                   
CODE_01E23F:                      STA.w $0300,y ; Draw X position.         
CODE_01E242:                      STA.w $0304,y    
CODE_01E245:                      LDA $01                   
CODE_01E247:                      STA.w $0301,y ; Draw Y position.        
CODE_01E24A:                      CLC                       
CODE_01E24B:                      ADC.b #$08                
CODE_01E24D:                      STA.w $0305,y    
CODE_01E250:                      LDA.b #$EB                
CODE_01E252:                      STA.w $0302,y          
CODE_01E255:                      LDA.b #$FB                
CODE_01E257:                      STA.w $0306,y         
CODE_01E25A:                      LDA.b #$30                
CODE_01E25C:                      STA.w $0303,y          
CODE_01E25F:                      STA.w $0307,y     
CODE_01E262:                      LDY.b #$00                
CODE_01E264:                      LDA.b #$01 ; We only wrote 2 tiles.               
CODE_01E266:                      JSL $01B7B3    
Return01E269:                     RTS                       ; Return 
                   
SPR_T1:             db $0C,$1C
SPR_T2:             db $01,$02

GET_DRAW_INFO:      STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X:        LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC #$0040            ;  |
                    CMP #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP:     LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y:        DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID:            PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

FixSolidSprites:
	LDA #$10
	STA $7D		; Restore hijack
	LDA $77
	ORA #$08
	STA $77		; Make the sprite block Yoshi from above.
	RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HurtEnd: