!RAM_Bank = $1DF9		;Which bank to use for sound effect?
!Value_Sound = $1C		;Which sound to use for sound effect?
!Value_Message = $03	;Which message to use? $01 -> Level Message 1; $02 -> Level Message 2; $03 - Yoshi Thanks Message

header		;ROM has a header...
lorom		;And is LoROM.
;fastrom	;Remove first semi-colon if your hack uses FastROM mapping.

reset bytes

org $00F358						;Sound effect part of Yoshi Coin collection subroutine
autoclean	JSL RAMCheck	;Replace with JSL RAMCheck
NOP #1							;Clear out 1 byte to prevent crashing

freedata	;Freespace

RAMCheck:
LDA #!Value_Sound		;Play sound effect
STA !RAM_Bank

LDA $1F2B				;Load flag
BEQ Show					;If 00, show message
RTL

Show:
LDA #!Value_Message	;Load message number
STA $1426
INC $1F2B					;Set the "collected one yoshi coin" flag
RTL

print "Inserted ",bytes," bytes at $",pc