;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Punch System by wiiqwertyuiop	;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
!FreeSpace	=	$108028	;;
!FreeRam		=	$58	;;
!ButtonToPunch	=	$40	;;
!Time		=	$05	;;
!Pose		=	$36	;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom


org $008E75
JSL PreparetoFight	 
NOP #2

org !FreeSpace 

!CodeSize = FightOver-PreparetoFight
db "STAR"
dw !CodeSize-$01
dw !CodeSize-$01^$FFFF

PreparetoFight:
JSL Fight
LDA $0F32               ;  |Copy time to $0F25-$0F27 
STA $0F26               ;  |    ;  \ hack the routine neccesary to start
RTL

DisableController:
STZ $15            ;  \
STZ $16            ;   | Keep the controller value zero, simulating no button press
STZ $17            ;   | This is JSR to to because it saves space, keeping some branches working
STZ $18            ;  /  (BRA, BNE, BCS, etc)
RTS

Fight:
LDA #$01
STA $19

LDA !FreeRam			;\ Check if the timer is set
BEQ CheckIfWeArePressingAnyButtons	;/ if not branch
LDA !FreeRam			;\ Check if the timer is set
BMI CheckIfWeArePressingAnyButtons	;/ if not branch

LDA #$04	;\
STA $13EE	; |Simulate sliding
LDA #$01	; |
STA $13ED	;/

LDA $74
BEQ Right
LDA #$FE
STA $7B
BRA Skip
Right:
LDA #$01
STA $7B
Skip:

JSR DisableController

LDA $13
AND #$02
BNE +
DEC !FreeRam
+
LDA #!Pose
STA $13E0
RTL

CheckIfWeArePressingAnyButtons:
ORA $73
ORA $74
ORA $75
ORA $1470
ORA $187A
BNE Cancel
LDA $71
CMP #$02
BCS Cancel
;LDA $15
;AND #!ButtonToPunch
;BNE SetTimer
LDA $16
AND #!ButtonToPunch
BNE SetTimer
Cancel:
RTL

SetTimer:
LDA #!Time
STA !FreeRam
RTL

FightOver: