;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Two Item Carry Glitch Fix;;
;;by Romi                  ;;
;cape/climbing fix by Alcaro;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;
org $01AA5E		;normal carryable sprites
;;;;;;;;;;;;;;;;;;;;;;;;;

			JSL CustomCode
			NOP #2
			db $80

;;;;;;;;;;;;;;;;;;;;;;;;;
org $01E6D2		;spring board
;;;;;;;;;;;;;;;;;;;;;;;;;

			JSL CustomCode
			NOP #2
			db $80

;;;;;;;;;;;;;;;;;;;;;;;;;
org $01ED3C		;yoshi
;;;;;;;;;;;;;;;;;;;;;;;;;

			JSL CustomCode
			NOP #2
			db $80

;;;;;;;;;;;;;;;;;;;;;;;;;
org $xxxxxx		;find free space in your rom! "0x1E bytes"
;;;;;;;;;;;;;;;;;;;;;;;;;

			db "STAR"
			dw End-CustomCode-$01
			dw End-CustomCode-$01^$FFFF

CustomCode:		LDA $1470
			ORA $187A
			ORA $1498
			;ORA $74;Uncomment to disallow carrying items while climbing
			ORA $1407;Comment out to allow carrying items while using the cape (no idea why you'd want that, though)
			BNE Return
			REP #$20
			PLA
			CLC
			ADC #$0004
			PHA
			SEP #$20
Return:			RTL
End:
