header
lorom

!freespace = $17D717 		;point it at some free space!

!low_level_num = #$29		;if level_num < #$25, then it equals level_num.
							;if level num > #$25, then it equals level_num - #$DC
							;this example uses level 105. 105 - DC = 29
							;remember to use hex values!
							;link to compute what value you should put here
							;http://www.google.com/search?q=0x105+-+0xDC
							
!level_timer_H = #$3		;timer setting for this level: the hundreds digit
!level_timer_T = #$0		;timer setting for this level: the tens digit
!level_timer_O = #$0		;timer setting for this level: the ones digit

org $00F606
	JML Main

org !freespace
db "STAR"					;RATS tag
dw End-Main-$01				;is here to protect data
dw End-Main-$01^$FFFF		;from being overwritten

Main:
	LDA !low_level_num
	CMP $13BF				;if the set level number is the same as the current level number
	BEQ doTeleport			;then restart the level

	LDA #$90				;otherwise, put back the four
	STA $7d					;bytes we overwrote and
	JML $00F60A				;finish dieing

doTeleport:
	LDA $5B					;check for horizontal/vertical level
	BEQ isHorizontalLevel	;it's 0 for horizontal level (I think)
	LDX $97					;if this is a vertical level, then get mario's current screen number in the Y direction
	BRA getLevelNum			;don't undo all of our hard work
isHorizontalLevel:
	LDX $95					;if this is a horizontal level, then get mario's current screen number in the X direction

getLevelNum:
	LDA $13BF				;load compressed level number
	CMP #$25				;if it is less than #$25
	BCC underHundred		;then don't mess with it
	CLC						;otherwise,
	ADC #$DC				;add #$DC to it to bring it up to the actual level number
underHundred:
	STA $19B8,x 			;store lower byte of level number to exit table
	CMP $25					;if the level number is in the upper range
	BCS highBitSet			;go set the "high bit" flag
	LDA #$00				;else clear the "high bit" flag
	BRA finishSetup
highBitSet:
	LDA #$01				;set the "high bit" flag
finishSetup:
	ORA #$04 				;add "exit is present" flag
	STA $19D8,x 			;store to exit table (right address?)
	LDA !level_timer_H		;reset the timer - hundreds
	STA $0F31				;reset the timer - hundreds
	LDA !level_timer_T		;reset the timer - tens
	STA $0F32				;reset the timer - tens
	LDA !level_timer_O		;reset the timer - ones
	STA $0F33				;reset the timer - ones
	LDA #$06 				;"enter a pipe" flag
	STA $71	 				;tell mario to enter a pipe (teleport)
	STZ $88	 				;warp wait time (=0)
	STZ $89	 				;enter right facing horizontal pipe
	JML $00F628				;go back to the end of the death routine to continue execution
	
End: