macro originalcode()
CODE_0085FD:        A9 FC         LDA.B #$FC                
CODE_0085FF:        85 00         STA $00                   
CODE_008601:        9C 15 21      STZ.W $2115               ; Set "VRAM Address Increment Value" to x00 ; VRAM Address Increment Value
CODE_008604:        9C 16 21      STZ.W $2116               ; Set "Address for VRAM Read/Write (Low Byte)" to x00 ; Address for VRAM Read/Write (Low Byte)
CODE_008607:        A9 50         LDA.B #$50                ; \ Set "Address for VRAM Read/Write (High Byte)" to x50 
CODE_008609:        8D 17 21      STA.W $2117               ; /  ; Address for VRAM Read/Write (High Byte)
CODE_00860C:        A2 06         LDX.B #$06                
CODE_00860E:        BD 49 86      LDA.W DATA_008649,X       
CODE_008611:        9D 10 43      STA.W $4310,X             
CODE_008614:        CA            DEX                       
CODE_008615:        10 F7         BPL CODE_00860E           
CODE_008617:        A0 02         LDY.B #$02                ; DMA something to VRAM, my guess is a tilemap... 
CODE_008619:        8C 0B 42      STY.W $420B               ; Regular DMA Channel Enable
CODE_00861C:        A9 38         LDA.B #$38                
CODE_00861E:        85 00         STA $00                   
CODE_008620:        A9 80         LDA.B #$80                
CODE_008622:        8D 15 21      STA.W $2115               ; VRAM Address Increment Value
CODE_008625:        9C 16 21      STZ.W $2116               ; \Change CRAM address ; Address for VRAM Read/Write (Low Byte)
CODE_008628:        A9 50         LDA.B #$50                ;  | 
CODE_00862A:        8D 17 21      STA.W $2117               ; / ; Address for VRAM Read/Write (High Byte)
CODE_00862D:        A2 06         LDX.B #$06                ; And Repeat the DMA 
CODE_00862F:        BD 49 86      LDA.W DATA_008649,X       
CODE_008632:        9D 10 43      STA.W $4310,X             
CODE_008635:        CA            DEX                       
CODE_008636:        10 F7         BPL CODE_00862F           
CODE_008638:        A9 19         LDA.B #$19                ; \but change desination address to $2119 
CODE_00863A:        8D 11 43      STA.W $4311               ; / ; B Address
CODE_00863D:        8C 0B 42      STY.W $420B               ; Start DMA ; Regular DMA Channel Enable
CODE_008640:        64 3F         STZ $3F                   ; $3B = 0 (not sure what $3B is) 
CODE_008642:        22 00 80 7F   JSL.L RAM_7F8000          ; and JSL to a RAM routine 
CODE_008646:        4C 49 84      JMP.W DoSomeSpriteDMA     ; Jump to the next part of this routine 


DATA_008649:                      .db $08,$18,$00,$00,$00,$00,$10
endmacro

header
lorom

org $0085FD
LDY #$00
Loop:
LDA R2115val,y
STA $2115
STZ $2116
LDA #$50
STA $2117
REP #$20
TYA
XBA
ORA #$1808
STA $4310
TYA
CLC
ADC.w #Tiles
STA $4312
STZ $4314
SEP #$20
LDA #$10
STA $4316
LDA #$02
STA $420B
INY
CPY #$02
BNE Loop
STZ $3F
JSL $7F8000
JMP $8449

R2115val:
db $00,$80
Tiles:
db $FC,$38

warnpc $008650