;;;
; Perfect SMB 3 Powerdown + Knockback
; Credit to Smallhacker & ICB
; Revisited and revised by endeppa

;;;
; Physics and freespace

;CHANGE THIS TO SOME FREESPACE!
!freeSpace = $xxxxxx

;Speed to be knocked backed with
;Second value is the same, but negative
!knockSpeed1 = $40
!knockSpeed2 = $C0

;;;
; MACRO information

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom
header

;;;
; Powerdown information

org $00F5F8
    JML Main
org $148000 ;the SNES adress the code will be inserted to this-
;-can be changed to anywhere in the ROM area
db "STAR"        ;\
dw $0080, $FF7F  ;/ A RATS tag used to protect 80 byte

Main:
LDA $19       	;\
CMP #$02      	; |If Mario has a flower or cape
BCS to_super  	; |then jump to Big Mario code.
STZ $19		; /set Mario to normal ($00)
LDA #$01	; \ Play Mario Shrink
STA $71		;/Animation
LDA #$29    	; |Time to play Animation
JML $00F61D	; Jump back

to_super:            	;\ 
LDA #$01      	; |Set Status
STA $19       	; /To Big
LDA #$0C	; \ Play another sound
STA $1DF9	; / that is closest to SMB3 sound
JSL $01C5AE	; \This is the 'get cape' animation, for the smoke puff
LDA #$11        	; /and we play it for a very short time
JML $00F61D	;| Jump Back

;;;
; Knockback information

; Hijack the hurt routine
org $00F5D5
    JML NewRoutine

; Remove the "Mario is shrinking" animation
; and replace it with setting the flash
; invincibility manually
org $00F5FC
    JSL MarioFlash

org !freeSpace
%RATS_start(0)

NewRoutine:
    LDA $19
    BEQ Die
    
    LDA #!knockSpeed2
    STA $7D
    
    LDA $76
    BNE Other
    
    LDA #!knockSpeed1
    STA $7B
    BRA End
    
Other:
    LDA #!knockSpeed2
    STA $7B
End:
    LDA $19
    CMP #$02
    BNE Pwr02

    JML $00F5DD
Pwr02:
    JML $00F5F3
Die:
    JML $00F606
    
MarioFlash:
	LDA #$7F
	STA $1497
	RTL

%RATS_end(0)
