lorom
header

; see the "rates" table at the bottom to change which moles/hammer rates to use for each level

; waiting times for the monty moles
!mole_wait_fast = $20
!mole_wait_slow = $68

; hammer frequencies (smaller values = faster rates)
!hammer_wait_fast = $0F
!hammer_wait_slow = $1F

org $01E2F3
	autoclean JML mole_hijack
	
org $01E2FB
	db !mole_wait_slow
	
org $01E301
	db !mole_wait_fast
	
org $02DA67
	db !hammer_wait_fast,!hammer_wait_slow
	
org $02DA79
	autoclean JML hammer_hijack

freecode

mole_hijack:
	PHX
	LDX $13BF
	LDA.l rates,x
	AND #$01
	PLX
	JML $81E2F9
	
hammer_hijack:
	PHX
	LDX $13BF
	LDA.l rates,x
	LSR
	AND #$01
	PLX
	JML $82DA7F

; VALID VALUES:
; $00 for fast moles + hammers
; $01 for slow moles, but fast hammers
; $02 for slow hammers, but fast moles
; $03 for slow moles + hammers
rates:
	db $02,$02,$02,$02,$02,$02,$02,$02	; levels 000-007
	db $02,$02,$02,$02,$02,$02,$02,$02	; levels 008-00F
	db $02,$02,$02,$02,$02,$02,$02,$02	; levels 010-017
	db $02,$02,$02,$02,$02,$02,$02,$02	; levels 018-01F
	db $02,$02,$02,$02,$02			; levels 020-024

	db $01,$01,$01,$01,$01,$01,$00,$00	; levels 101-108
	db $00,$00,$00,$00,$00,$00,$00,$00	; levels 109-110
	db $00,$00,$00,$00,$00,$00,$00,$00	; levels 111-118
	db $00,$00,$00,$00,$00,$00,$00,$00	; levels 119-120
	db $00,$00,$00,$00,$00,$00,$00,$00	; levels 121-128
	db $00,$00,$00,$00,$00,$00,$00,$00	; levels 129-130
	db $00,$00,$00,$00,$00,$00,$00,$00	; levels 131-138
	db $00,$00,$00				; levels 139-13B
