;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Invincible Mario palette changer
; By Smallhacker
; 
; Makes invincible Mario use a single palette
; (Sprite palette 7 by default)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Mario's palette when invincible (multiplied by two)
!marioPalInv = $0E

;CHANGE THIS ADDRESS TO A FREE SECTION OF THE ROM!
!freeSpace = $0FEF90

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Hijack the routine loading Mario's palette
org $00E3CD
    JSL NewPalRoutine
    NOP

org !freeSpace
%RATS_start(0)

NewPalRoutine:
    LDX $1490
    BEQ Normal
	
    LDX $76
    ORA $E18C,X
    AND #$F1
    ORA #!marioPalInv
    
    RTL
Normal:
    LDX $76
    ORA $E18C,X
    RTL

%RATS_end(0)