

!Freespace = $168BEC
!MaxSpeedRight = $21		; Maximum speed right.
!MaxSpeedLeft  = $DE		; Maximum speed left.

Header
LoROM

;---------
;Hex Edits;
;---------

org $00D66F
	db $80 ; Disable air flight/max speed.

;-----------
org $8DC4
JSL NoRun
NOP
org !Freespace	
!CodeSize = Ending-Routine 	
db "STAR"			
dw !CodeSize-$01
dw !CodeSize-$01^$FFFF
Routine:
;---------------------

NoRun:
	LDA #$02			; Restore
	STA $420B			; Hacked code.
	LDA $7B				; If speed is negative (#$80-#$FF)..
	BMI Left			; Check maximum left speed.
	CMP #!MaxSpeedRight		; Else check if ..
	BPL Limit			; ...maximum speed limit for right reached.
Left:
	CMP #!MaxSpeedLeft
	BMI LimitLeft			; Return if not going lower than maximum.
	RTL
Limit:
	LDA #!MaxSpeedRight		; Get maximum right speed ...
	BRA SetSpeed			; And store it.
LimitLeft:
	LDA #!MaxSpeedLeft		; Store maximum left speed.
SetSpeed:
	STA $7B
	RTL
;---------
;END RATS;
;---------
Ending: