;overworld counters

!yicoinpos	= $509E
!coinpos	= $5363
!scorepos	= $5378

header : lorom

org $0081EC
autoclean JML owcount


freecode

owcount:
LDA $0D9B
LSR : BNE +
JML $0081F2
+
LDA $0100
CMP #$0D : BEQ +
LDA $13D9
CMP #$05 : BEQ +
CMP #$08 : BEQ +
BRA ++
+
JSR OWYICoin		;remove to disable
JSR OWCoin		;remove to disable
JSR OWScore		;remove to disable
++
JML $008222

OWYICoin:
LDY $0DD6
LDA $1F17,y
LSR #4 : STA $00
LDA $1F19,y
AND #$F0
ORA $00 : STA $00
LDA $1F1A,y
ASL : ORA $1F18,y
LDY $0DB3
LDX $1F11,y
BEQ +
CLC : ADC #$04
+
STA $01

REP #$10
LDX $00
LDA $7ED000,x
STA $02
SEP #$10

LDA #$FF : STA $00	;no yoshi coin tile
LDA #$28 : STA $01	;no yoshi coin palette

PHB : PHK : PLB
LDX.b #.endtable-.table-1
-
LDA $02
CMP .table,x
BEQ +
DEX : BPL -
LSR #3
TAY
LDA #$78 : STA $00	;empty yoshi coin tile
LDA #$39 : STA $01	;empty yoshi coin palette
LDA $02
AND #$07
TAX
LDA $1F2F,y
AND $05B35B,x
BEQ +
LDA #$8E : STA $00	;complete yoshi coin tile
LDA #$28 : STA $01	;complete yoshi coin palette
+
PLB

REP #$20
LDX #$80 : STX $2115
LDA #!yicoinpos : STA $2116
LDA $00 : STA $2118
SEP #$20
RTS

.table			;these are translevels that don't have yoshi coins
;levels $00-$24
db $00,$03,$04,$07,$08,$0B,$0E,$12
db $13,$14,$16,$18,$1A,$1B,$1E,$1F
db $21
;levels $101-$13B (values listed are levelnum-$DC)
db $101-$DC,$104-$DC,$108-$DC,$10C-$DC,$10D-$DC,$10E-$DC,$10F-$DC,$111-$DC
db $117-$DC,$11B-$DC,$11C-$DC,$11E-$DC,$121-$DC,$124-$DC,$129-$DC,$12E-$DC
db $12F-$DC,$130-$DC,$131-$DC,$132-$DC,$133-$DC,$135-$DC,$136-$DC,$137-$DC
db $138-$DC
.endtable


OWCoin:
LDA #$8E : STA $00		;coin tile
LDA #$28 : STA $01		;coin prop
LDA #$8F : STA $02		;coin X
LDA #$38 : STA $03		;coin X prop
LDA #$39 : STA $05 : STA $07	;coin number prop

LDX $0DB3
LDA $0DB6,x
LDX $0DB2
BNE +
LDA $0DBF
+
LDX #$00
-
CMP #$0A
BCC +
SBC #$0A
INX
BRA -
+
CLC : ADC #$22
STA $06
TXA
CLC : ADC #$22
CMP #$22
BNE +
LDX $06
LDA #$1F
STA $06
TXA
+
STA $04
REP #$20
LDX #$80 : STX $2115
LDA #!coinpos : STA $2116
LDX #$00 : LDY #$03
-
LDA $00,x : STA $2118
INX #2 : DEY : BPL -
SEP #$20
RTS


OWScore:
LDA #$1F : STA $00 : STA $02 : STA $04 : STA $06 : STA $08 : STA $0A
LDA #$39 : STA $01 : STA $03 : STA $05 : STA $07 : STA $09 : STA $0B	;properties of score

LDX $0DB3 : BEQ +
LDX #$03
+
LDA $0F34,x
STA $0C
LDA $0F35,x
STA $0D
LDA $0F36,x
STA $0E
STZ $0F

LDX #$00
LDY #$00

PHA : PHA : PHA : PHA
-
SEP #$20
STZ $00,x
--
REP #$20
LDA $0C
SEC : SBC $8FFC,y
STA $03,s
LDA $0E
SBC $8FFA,y
STA $01,s
BCC +
LDA $03,s
STA $0C
LDA $01,s
STA $0E
SEP #$20
INC $00,x
BRA --
+
INX #2
INY #4
CPY #$18
BNE -
SEP #$20
PLA : PLA : PLA : PLA

LDA $00
BNE +
LDA #$1F		;leading 0 becomes empty space
+
STA $00

LDX #$00
-
LDA $02,x
TAY
BNE +
LDA $00,x
CMP #$1F		;same here
BNE +
LDY #$1F		;"
+
TYA
STA $02,x
INX #2 : CPX #$0A : BCC -

LDX #$0A
-
LDA $00,x
CMP #$1F		;"
BEQ +
CLC : ADC #$22
+
STA $00,x
DEX #2 : BPL -

LDA #$22 : STA $0C	;end zero tile
LDA #$39 : STA $0D	;end zero prop

REP #$20
LDX #$80 : STX $2115
LDA #!scorepos : STA $2116
LDX #$00 : LDY #$06
-
LDA $00,x : STA $2118
INX #2 : DEY : BPL -
SEP #$20
RTS