;;Powerup Hacking Kit - By ICB
;;This patch is for those who want the defualt powerups in SMW to do something 
;;besides the default action when collected. There are example codes included
;;but they can be changed to whatever you need them to do.

header
lorom

;; Remove the Semicolons next to the org and JML lines
;; to hack that specific powerup's routine, otherwise
;; leave them there if you wish to keep them as default. **Changing
;; the code ONCE will change it for good** so unless you wish to go back 
;; and fix the code in Hex using all.log, BACK UP YOUR ROM!

;;Example Codes Below Are:
;;Mushroom - Bounces Mario like springboard
;;Star - Gives Mario 16 bonus stars
;;Feather - Gives two Yoshi coins
;;Flower - Turns into a Yoshi Egg
;;1Up Mushroom - Switches between Mario and Luigi.

;org $01C561
;	JML Mushroom	; New Mushroom pickup code

;org $01C592
;	JML Star		; New Star pickup code

;org $01C598
;	JML Feather  	; New Feather pickup code

;org $01C5EC
;	JML flower 	; New Flower Pickup code

;org $01C5FE
;	JML oneup  	; New 1UP pickup code


; -------------------------------------------
org $0D8f30		; address to put code
; -------------------------------------------
db "STAR"		; Write RATS tag
dw Endcodeblock-Startcodeblock
dw Endcodeblock-Startcodeblock^#$FFFF
; -------------------------------------------
Startcodeblock:		; code starts here
; -------------------------------------------
Mushroom:	;New Mushroom code goes below.
LDA #$0B
STA $72
LDY #$80
STY $1406
STY $7D
LDA #$08
STA $1DFC
BRA RETURN	;Return (leave this here)

Star:		;New Star code goes below.
LDA #$29
STA $1DFC
LDA $0F48
CLC
ADC #$10
STA $0F48
BRA RETURN	;Return (leave this here)

Feather:		;New Feather code goes below.
LDA #$1c
STA $1DF9
LDA #$03
STA $1422
JML $01C5AD	;Return to Feather RTS. It crashes otherwise. Hmm.. (leave this)

flower:		;New Flower code goes below.
LDA #$2C
STA $9E,x
LDA #$01
STA $14C8,x
BRA RETURN	;Return (leave this here)

oneup:		;New 1up Mushroom code goes below.
LDA #$0D
STA $1DF9
JSL $01C5AE
LDA $0DB3
EOR #$01
STA $0DB3

RETURN:			;Return (leave this here)
JML $01C608		;jump back to shared routine RTS...


; -------------------------------------------
Endcodeblock:		; code ends here	
; -------------------------------------------