;===================
;Timer die flag
;Sets an flag that teleports you if !FreeRAM = #$01 and kills you if !FreeRAM is #$00
;Also, it's somewhat customizable, you can change the messages, ranging from Game Over to Time Up!
;===================

HEADER
LOROM

!Freespace = $268000	;Point Freespace Code
!RAM = $0660		;Default RAM, change if necessary

org $008E6B
JML New

org !Freespace

db "STAR"
dw EndCode-StartCode-$01
dw EndCode-StartCode-$01^$FFFF

StartCode:

New:
LDA !RAM
BEQ TimeOver
BNE NotOverYet
RTL

TimeOver:

JSL $80F606		;\Time's over
JML $808E6F		;/Mario dies, no more than that, here.

NotOverYet:

LDA #$80			;\Change to any music you want
STA $1DFB		;/currently, is set to fade out music

STZ $14			;\
			;|Freeze Sprites
LDA #$01			;|
STA $9D			;/

LDY #$15		;\Fade out to Time Over
STY $0100		;/

LDX #$1D		;\Change message to TIME UP!
STX $143B		;/

LDA #$C0			;\Death message animation timer
STA $143C		;/

JML $808E6F		;Return

EndCode: