;=================================================================================================
; Time Up + SFX Patch, by Lui37 (user ID 16989 at SMWCentral)   
; To be assembled with Asar
;
; Description:
; With this patch you can have a SFX of your choice, to play when TIME UP screen appears,
; pretty much like the GAME OVER one does.
;
; Notes:
; Thanks to DiscoMan for fixing the jumps!
;=================================================================================================

lorom
header

; Defines

!SFX_To_Play = $18
!SFX_Bank = $1DFB

; For more informations about SFX, check out the link below
; http://www.smwcentral.net/?p=viewthread&t=6665

org $00D0E6
autoclean JML SomeLabel

freecode

SomeLabel:
LDY #$0B                ; Set Y (game mode) to x0B (Fade to overworld) 
LDA $0F31               ; \
ORA $0F32               ; | If time isn't zero... 
ORA $0F33               ; | Don't show the time up message
BNE NotTimeUp           ; /
LDA #!SFX_To_Play       ; \
STA !SFX_Bank           ; / Change music
JML $00D0F3             ; Jumps back to death routine

NotTimeUp:
JML $00D104