header
lorom

;Yoshi-Springboard Clipping Fix patch by lolcats439
;Fixes the Yoshi-Springboard glitch where you eat the springboard while walking on top of it, and clip through the blocks above.

;The fix is basically to check if the springboard is being eaten during the code that moves Mario above the springboard, and if so, not change Mario's Y position.


!FREESPACE = $17F997  ; change to freespace


org $01E669           ;\ Hijack code and JSL to custom code
JSL CodeStart         ;/
BRA SkipNOPs
NOP #13
SkipNOPs:
STZ $72               ; Make sure Mario is not flying anyway


org !FREESPACE
!CodeSize = CodeEnd-CodeStart ;\ 
RATS:                 ;| Write RATS tag to
db "STAR"             ;| prevent other programs
dw !CodeSize-$01      ;| from overwriting this 
dw !CodeSize-$01^$FFFF;/ code!

CodeStart:
PHY
LDY $15D0,x
BNE SkipIfBeingEaten
STA.w $1602,x         ;\ restore overwritten code
LDA $D8,x             ;|
SEC                   ;|
SBC $00               ;|
STA $96               ;|
LDA.w $14D4,x         ;|
SBC.b #$00            ;|
STA $97               ;|
STZ $7B               ;/
SkipIfBeingEaten:
PLY
RTL
CodeEnd:

