;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; OAM Remapper Patch 1.0, by imamelia
;;
;; This patch allows you to remap all sprite tiles that use OAM addresses in the
;; $0200-$02FF range to any other slot in that range.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

; Yoshi's tongue (first tile; it always uses 5 in a row)
org $01F469
db $0C

; block bounce sprites
org $0291ED
db $10,$14,$18,$1C

; smoke image 01 - puff of smoke
org $0296B8
db $20,$24,$28,$2C

; smoke image 02 - contact graphic, in normal levels (the next slot after this one is also used)
org $0297B3
db $F0

; smoke image 02 - contact graphic, in special boss levels (the next slot after this one is also used)
org $029839
db $90

; spinning coins from blocks (the next slot after each of these is also used)
org $0299E9
db $30,$38,$40,$48

; minor extended sprites
org $028B78
db $50,$54,$58,$5C,$60,$64,$68,$6C,$70,$74,$78,$7C

; cluster sprite 01 - 1-Up from bonus game
org $02FF64
db $90,$94,$98,$9C,$A0,$A4,$A8,$AC

; cluster sprite 03 - Boo from ceiling, 04 - Boo from Boo ring, 06 - Sumo Brother flame tile, 07 - reappearing Boo, 08 - death bat ceiling
org $02FF50
db $E0,$E4,$E8,$EC,$F0,$F4,$F8,$FC,$5C,$58
db $54,$50,$4C,$48,$44,$40,$3C,$38,$34,$30

; cluster sprite 05 - background candle flame
org $02FA0A
db $F0,$F4,$F8,$FC

; extended sprites
org $02A153
db $90,$94,$98,$9C,$A0,$A4,$A8,$AC

; score sprites
org $02AD9E
db $B0,$B8,$C0,$C8,$D0,$D8

; item box item
org $00907A
db $E0

; the player's fireballs
org $029FAB
db $F8,$FC





