header
lorom

org $008F32  ;Jump to the 100 coin routine
JSL CoinChecker  ;Jump to the main code
NOP #5  ;Prevent freezing

org $258000  ;Point this to some freespace, if you don't want the Blank Screen of Death.

db "STAR"                        ;\ 
dw End-CoinChecker-$01           ; |RATS tag
dw End-CoinChecker-$01^$FFFF     ;/

CoinChecker:
LDA $0DBF  ;Load Mario's coins in the Accumulator.
CMP #$64  ;Check if the value in A is 100
BEQ GivePowerup  ;If so, then jump to GivePowerup
RTL  ;Return

GivePowerup:
LDA $19 ;Load Mario's powerup in A.
BEQ Mushroom ;If Mario has nothing, then jump to Mushroom
CMP #$01 ;If Mario has a Mushroom, then...
BEQ Flower ;Jump to Flower
CMP #$03 ;If Mario has a Flower, then...
BEQ Cape ;Jump to Cape
CMP #$02 ;If Mario has a cape, then...
BEQ Star ;Jump to Star

Mushroom:
LDA #$01  ;Load 01 into A
STA $19 ;Load 01 into RAM Address 19
LDA $0DBF ;|
SEC       ; \ Decrease Mario's coins by 100
SBC #$64  ; / Taken from all.log
STA $0DBF ;|
JMP CoinChecker

Flower:
LDA #$03 ;Load 03 into A
STA $19 ;Load 03 into RAM Address 19
LDA $0DBF ;|
SEC       ; \ Decrease Mario's coins by 100
SBC #$64  ; / Taken from all.log
STA $0DBF ;|
JMP CoinChecker

Cape:
LDA #$02 ;Load 02 into A
STA $19 ;Load 02 into RAM Address 19
LDA $0DBF ;|
SEC       ;\ Decrease Mario's coins by 100
SBC #$64  ; / Taken from all.log
STA $0DBF ;|
JMP CoinChecker

Star:
LDA #$FF     ;|
STA $1490    ;\ 
LDA #$0D     ; \ 
STA $1DFB    ;  |Starman
ASL $0DDA    ; /
SEC          ;/
ROR $0DDA    ;|
LDA $0DBF ;|
SEC       ; \ Decrease Mario's coins by 100
SBC #$64  ; / Taken from all.log
STA $0DBF ;|
JMP CoinChecker

End: ;End of RATS tag