!FreeSpace 	= 	$128000		; Freespace
!FreeRam 	=	$58		; Make sure its the same one as the sprites and block!

header
lorom

org $008F55      
NOP #2
JSL NewCode


org $00F5B7
JSL CustomCode

org !FreeSpace

!CodeSize = End-Start ; <- RATS Tag define.
db "STAR"
dw !CodeSize-$01
dw !CodeSize-$01^$FFFF
Start: ;<- Beginning of RATS Tag, and bytes to protect.


CustomCode:
LDA !FreeRam
BEQ RestoreOldCode
LDA !FreeRam
CMP #$80
BCC RestoreOldCode


LDA #$05
STA $1497
Return:
RTL

RestoreOldCode:
LDA $71			  ; \ Return if animation sequence activated 
BNE Return	          ; / 
RTL


NewCode:
STX $0F16               ; \ Write lives to status bar 
STA $0F17               ; /  

LDA !FreeRam
BNE YourInvisible
RTL

YourInvisible:
LDA !FreeRam
CMP #$80
BCS Return

LDA #$05
STA $1497
LDA $14
AND #$03
BNE +
LDA #$FF
STA $78
+
LDA $13
AND #$7F
BNE ++
DEC !FreeRam
++
RTL


End: ; <- End of RATS Tag and number of bytes to protect..

