header
lorom

;========================
; DEFINES
;========================

!CodeFreeSpace = $1E8000  ; REPLACE WITH FREESPACE ADDRESS!!!

!FreeRAM = $010B
!AnotherRAM = $06B0
!ThirdRam = $06B1         ; You may want to change this.

!DefaultMarSm = $00B2C8   ; \ You may not want to change these.
!DefaultLuiSm = $00B2DC   ;  |
!DefaultMarBg = $00B2C8   ;  |
!DefaultLuiBg = $00B2DC   ;  |
!DefaultMarCp = $00B2C8   ;  |
!DefaultLuiCp = $00B2DC   ;  |
!DefaultMarFr = $00B2F0   ;  |
!DefaultLuiFr = $00B304   ; /

;----------------
; Hijacks.
;----------------

org $00A31A
JML NotQuiteMain

org $00B048
JSL LessMainThanThat

org $00E31B
JML Main

;==========================
; FROM LEVELASM, NOT BY ME
;==========================

ORG $05D8B9
	JSR Levelnummain

ORG $05DC46
Levelnummain:	LDA $0E  		;Load level number
		STA !FreeRAM		;Store it in free stack RAM
		ASL A    		;Multiply A by 2, probably to recover old code?
                STZ !AnotherRAM
		RTS      		;Return from subroutine


;-----------------------
; Custom Routine
;-----------------------

org !CodeFreeSpace

!CodeSize = End-Main

db "STAR"
dw !CodeSize-$01
dw !CodeSize-$01^$FFFF

Main:
LDY $0D9B
CPY #$02
BEQ LoadDefaults
REP #$30
AND #$00FF                              ; \ A * 256.
XBA                                     ;  |
CLC                                     ;  | + current level num.
ADC !FreeRAM                            ;  |
STA $00                                 ; / Into $00 (scratch)
ASL A                                   ; \ Result *3
CLC                                     ;  |
ADC $00                                 ;  |
TAX                                     ; / Result of that into X.
LDA PalPtr,x                            ; \ Get low and middle byte into $0D82.
STA $0D82                               ; /
SEP #$20                                
LDA PalPtr+2,x                          ; Get bank byte into !ThirdRam.
STA !ThirdRam
SEP #$10

JumpBack:
JML $00E326                             

LoadDefaults:
TAX                                     
REP #$20                                
LDA $00E2A2,x                           ; \ Load from default palettes.
STA $0D82                               ; / Store here.
SEP #$20
STZ !ThirdRam                           ; Must be 00.
BRA JumpBack

NotQuiteMain:
LDY !ThirdRam
STY $4324
JML $00A31F

LessMainThanThat:
LDA !ThirdRam
STA $02
RTL

;---------------------
; Mario, Small
;---------------------

PalPtr:
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 0-F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 10-1F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 20-2F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 30-3F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 40-4F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 50-5F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 60-6F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 70-7F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 80-8F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 90-9F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels A0-AF
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels B0-BF
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels C0-CF
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels D0-DF
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels E0-EF
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels F0-FF
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 100-10F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 110-11F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 120-12F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 130-13F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 140-14F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 150-15F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 160-16F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 170-17F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 180-18F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 190-19F
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 1A0-1AF
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 1B0-1BF
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 1C0-1CF
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 1D0-1DF
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 1E0-1EF
dl !DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm,!DefaultMarSm ; Levels 1F0-1FF

;-------------------
; Luigi, Small
;-------------------

dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 0-F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 10-1F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 20-2F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 30-3F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 40-4F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 50-5F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 60-6F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 70-7F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 80-8F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 90-9F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels A0-AF
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels B0-BF
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels C0-CF
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels D0-DF
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels E0-EF
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels F0-FF
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 100-10F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 110-11F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 120-12F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 130-13F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 140-14F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 150-15F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 160-16F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 170-17F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 180-18F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 190-19F
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 1A0-1AF
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 1B0-1BF
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 1C0-1CF
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 1D0-1DF
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 1E0-1EF
dl !DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm,!DefaultLuiSm ; Levels 1F0-1FF

;-----------------
; Mario, Big
;-----------------

dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 0-F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 10-1F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 20-2F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 30-3F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 40-4F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 50-5F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 60-6F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 70-7F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 80-8F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 90-9F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels A0-AF
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels B0-BF
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels C0-CF
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels D0-DF
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels E0-EF
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels F0-FF
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 100-10F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 110-11F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 120-12F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 130-13F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 140-14F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 150-15F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 160-16F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 170-17F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 180-18F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 190-19F
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 1A0-1AF
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 1B0-1BF
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 1C0-1CF
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 1D0-1DF
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 1E0-1EF
dl !DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg,!DefaultMarBg ; Levels 1F0-1FF

;-----------------
; Luigi, Big
;-----------------

dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 0-F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 10-1F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 20-2F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 30-3F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 40-4F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 50-5F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 60-6F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 70-7F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 80-8F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 90-9F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels A0-AF
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels B0-BF
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels C0-CF
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels D0-DF
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels E0-EF
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels F0-FF
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 100-10F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 110-11F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 120-12F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 130-13F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 140-14F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 150-15F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 160-16F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 170-17F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 180-18F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 190-19F
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 1A0-1AF
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 1B0-1BF
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 1C0-1CF
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 1D0-1DF
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 1E0-1EF
dl !DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg,!DefaultLuiBg ; Levels 1F0-1FF

;----------------
; Mario, Cape
;----------------

dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 0-F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 10-1F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 20-2F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 30-3F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 40-4F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 50-5F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 60-6F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 70-7F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 80-8F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 90-9F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels A0-AF
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels B0-BF
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels C0-CF
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels D0-DF
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels E0-EF
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels F0-FF
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 100-10F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 110-11F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 120-12F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 130-13F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 140-14F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 150-15F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 160-16F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 170-17F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 180-18F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 190-19F
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 1A0-1AF
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 1B0-1BF
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 1C0-1CF
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 1D0-1DF
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 1E0-1EF
dl !DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp,!DefaultMarCp ; Levels 1F0-1FF

;----------------
; Luigi, Cape
;----------------

dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 0-F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 10-1F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 20-2F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 30-3F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 40-4F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 50-5F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 60-6F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 70-7F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 80-8F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 90-9F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels A0-AF
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels B0-BF
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels C0-CF
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels D0-DF
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels E0-EF
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels F0-FF
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 100-10F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 110-11F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 120-12F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 130-13F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 140-14F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 150-15F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 160-16F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 170-17F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 180-18F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 190-19F
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 1A0-1AF
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 1B0-1BF
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 1C0-1CF
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 1D0-1DF
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 1E0-1EF
dl !DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp,!DefaultLuiCp ; Levels 1F0-1FF

;----------------
; Mario, Fire
;----------------

dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 0-F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 10-1F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 20-2F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 30-3F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 40-4F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 50-5F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 60-6F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 70-7F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 80-8F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 90-9F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels A0-AF
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels B0-BF
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels C0-CF
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels D0-DF
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels E0-EF
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels F0-FF
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 100-10F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 110-11F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 120-12F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 130-13F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 140-14F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 150-15F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 160-16F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 170-17F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 180-18F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 190-19F
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 1A0-1AF
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 1B0-1BF
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 1C0-1CF
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 1D0-1DF
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 1E0-1EF
dl !DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr,!DefaultMarFr ; Levels 1F0-1FF

;----------------
; Luigi, Fire
;----------------

dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 0-F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 10-1F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 20-2F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 30-3F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 40-4F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 50-5F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 60-6F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 70-7F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 80-8F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 90-9F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels A0-AF
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels B0-BF
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels C0-CF
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels D0-DF
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels E0-EF
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels F0-FF
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 100-10F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 110-11F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 120-12F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 130-13F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 140-14F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 150-15F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 160-16F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 170-17F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 180-18F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 190-19F
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 1A0-1AF
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 1B0-1BF
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 1C0-1CF
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 1D0-1DF
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 1E0-1EF
dl !DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr,!DefaultLuiFr ; Levels 1F0-1FF

;-----------------------------------------------------------------------------------------
; Custom Palettes
; Format: SNES RGB values.
; You can get these with the LM palette viewer.
; If you want, you can insert more palettes underneath this.
; Give them a label (such as Pal10: and on), then make colours for them.
; Amount of colours should be 10 per custom palette (replace colours 6-F from palette 8)
;-----------------------------------------------------------------------------------------

Pal0:
dw $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
Pal1:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
Pal2:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
Pal3:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
Pal4:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
Pal5:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
Pal6:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
Pal7:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
Pal8:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
Pal9:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
PalA:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
PalB:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
PalC:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
PalD:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
PalE:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF
PalF:
dw $635F,$581D,$000A,$391F,$44C4,$4E08,$6770,$30B6,$35DF,$03FF

End: