;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
!FreeRam = $1F2B			; MUST be the same as the srpite
!Freespace = $108028		; Freespace
!FreeRam2 = $17BB		; More freeram. 
!Time = $1F			; Starting time
!Compare = $04			; Time to activate
!Sound = $01			; Sound to play
!Bank = $1DFA			; Bank
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

org $008E81
JSL SPEED



org !Freespace

SPEED:
LDX #$10                ;\
LDY #$00

LDA !FreeRam		;\ Check if we have the powerup
BEQ Done		;/

   


LDA $13E4		;\
CMP #$70		; | Check if we are running
BEQ INCs		;/

LDA $1490		;\ 
CMP #$01		; | Check if we have a star
BCS DoIt			;/

LDA #$01
STA !FreeRam

LDA #!Time		;\ Set timer
STA !FreeRam2		;/

Done:
RTL



INCs:
LDA !FreeRam2		;\
CMP #!Compare		; | Check if timer is 0
BCC Start			;/

DEC !FreeRam2		; Decrease timer
RTL

Start:
LDA #$FF
STA $1490

LDA #!Sound           ; \ Sound Efffect
STA !Bank               ; / 
           
RTL


DoIt:
LDA $1490
CMP #$20
BEQ End

LDA $77		;\
AND #$04		;| If we air in the air check what button we are pressing
BEQ Button	;/ 





DEC $1490
RTL

End:
JSR Finally
RTL

Button:
LDA !FreeRam
CMP #$FF
BEQ Up




LDA !FreeRam
CMP #$FD
BEQ Right

LDA !FreeRam
CMP #$FC
BEQ Left

LDA $16		;\
CMP #$08	; |
BEQ Up		; |
		; | What buttons to press
		; | (possible values: 01=Right, 02=Left, 04=Down, 08=Up, 10=Start,
		; | 20=Select, 40=Y and X, 80=B and A)
LDA $16		; |
CMP #$01	; |
BEQ Right	; |
LDA $16		; |
CMP #$02	; |
BEQ Left		;/

RTL



Up:


LDA $77
CMP #$08
BEQ StopU

LDA #$0F
STA $13E0

LDA #$FF
STA !FreeRam
LDA #$80
STA $7D

STZ $7B
RTL



Right:
LDA $77
AND #$03
BNE Stop


LDA #$0C
STA $13E0

LDA #$01
STA $76

LDA #$FD
STA !FreeRam
STZ $7D
LDA #$7F
STA $7B
DEC $1490
RTL

StopU:
STZ $7D
STZ $7B
LDA #$09
STA $1DFC
STZ $1490
LDA #$50
STA $1887
RTL

Left:
LDA $77
AND #$03
BNE Stop



LDA #$0C
STA $13E0

STZ $76
LDA #$FC
STA !FreeRam
STZ $7D
LDA #$80
STA $7B
DEC $1490
RTL

Stop:
STZ $7D
LDA #$09
STA $1DFC
STZ $1490
LDA #$50
STA $1887
LDA $76
BEQ OtherWay
LDA #$CF
STA $7B
RTL

Finally:
STZ $1490
RTS

OtherWay:
LDA #$30
STA $7B
RTL
