;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Floating Patch, made by Leod
;This Patch will make Mario slowly Float down after each Jump or if hes just falling
;To fall normal, hold Down. If you release down again, he will start floating again.
;If you don't uncomment the BRA Return later down, Mario will also show the two Burned Frames while floating down.
;That's made for if you want some floating animation, like fluttering Wings or something.
;Please tell ma if there are any Bugs, and if anyone knows how to make the Frames code shorter, tell me.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!freeSpace = $108196
!freeram = $662
!freeram2 = $663

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $008F49
	JSL Routine

org !freeSpace
%RATS_start(0)

Routine:
	LDA $77		;Check if in Air
	CMP #$00		;Same
	BEQ buttonUp		;If yes, GoBranch
	CMP #$02
	BEQ buttonUp
	CMP #$01
	BEQ buttonUp
	LDA #$09		;How long should the InitFrame get shown?
	STA !freeram2

    BRA Return    	;If not, GoNotBranch



buttonUp:
    LDA $15    		;Check if pressing Up
    AND #$04
    BEQ Pressy
    BRA Return


Pressy:
	LDA $7D		;Check if falling
	CMP #$80		;Same
	BCC MahGod		;If yes, MahGod
	BRA Return  	;If not, End
	
MahGod:
	LDA #$08
	STA $7D
	LDA !freeram2	;Check for Init
	CMP #$01		;Check for Init
	BCS Initframe	;Check for Init
	LDA !freeram
	CMP #$00
	BEQ Frame1
	CMP #$01
	BEQ Frame1
	CMP #$02
	BEQ Frame1
	CMP #$03
	BEQ Frame1
	CMP #$04
	BEQ Frame2
	CMP #$05
	BEQ Frame2
	CMP #$06
	BEQ Frame2
	CMP #$07
	BEQ Frame2
	CMP #$08
	BEQ Frame3

Initframe:
	LDA #$0D		;looking at castle (flying) Frame
	STA $13E0
	DEC !freeram2	;InitframeLoop
	BRA Return

	
Frame1:
	LDA #$30
	STA $13E0
	INC !freeram
	BRA Return	

Frame2:
	LDA #$31
	STA $13E0
	INC !freeram
	BRA Return
	
Frame3:
	LDA #$30
	STA $13E0
	STZ !freeram
	
Return:
	LDA $0DBE
	INC A 
    RTL

%RATS_end(0)