;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Flutter Jump
;;By Scepile3
;;
;;Notes:
;;*I use the RAM Addresses $0660 (For Flutter Jump Indicator. if used or not and pose to show)
;;
;;*How do you make a RATS tag? I think that's the reason for the freezing...
;;
;;Original code from:
;; LR Hook - Version 1.1
;; By Smallhacker
;; 
;; Disables L/R and prepares them to be used for other stuff
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
org $34B64 ;;change this to free space in rom
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Disable L/R scrolling
org $34B64
org $00CDF6
    BRA lrSkip
org $00CE49
lrSkip:

;Hijack the status bar routine
org $008F49
        JSL NewRoutine

org $34B64
%RATS_start(0)

NewRoutine:
    LDA $77        ;(in order)Doesn't work if not in air, swimming, climbing, or on yoshi
    AND #$04
    BNE Reset
    LDA $75
    BNE Return
    LDA $74
    BNE Return
    LDA $187A
    BNE Return
    LDA $140D     ;remove this line if you don't want to allow mario to flutter while spin jumping
    BNE Check     ;remove this line if you don't want to allow mario to flutter while spin jumping
    LDA $0660
    BEQ Check
    LDA $1499     ;temperarily stops when facing screen
    BNE Return    ;to add more, find what you want the flutter to not show in the ram map. add a new line saying:LDA $...[your ram address/es] and another line saying :BNE Return
                  ;right after each adress if it's like a true or false)If not, find value or values you want to exclude in that address and instead of BNE Return, put: BEQ Return
                  ;right after an operand that compares(be sure that you know how to use it) with the value you want to exclude
    LDA $7D
    CMP #$7F
    BCC Return
    LDA $1470
    BNE Carry
    LDA $148F
    BNE Carry
    LDA $0660
    CMP #$02      ;(to slow feet)increase this[!]
    BCS Stand     ;you should also delete this line if you don't want to show poses
    LDA #$05      ;to change 1st pose, change this. full list of poses in documents section of smwcentral.net
    STA $13E0     ;don't change if you want pose. if you don't want to show any pose, delete this line and the one above this
    INC $0660     ;you should also delete this line if you don't want to show poses
    BRA Return
Check:
    LDA $16       ;change these two lines to alter which button you want to press. controller values are in the RAM section of smwcentral.net
    CMP #$80
    BNE Return
    STZ $140D     ;remove this line if you don't want to allow mario to flutter while spin jumping (without this, mario spin flutters)
    LDA #$BF      ;Change to alter flutter jump's boost(FF, 80, and 0 are nothing. 81-FE are rising(FE being the least boost) and 1-7F are falling (1 being the slowest)
    STA $7D
    INC $0660
    LDA #$01      ;to change sound played, change the 01 to something else.(currently jump)
                  ;full list of sounds are at: http://www.smwcentral.net/?p=thread&id=6665
    STA $1DFA     ;to change music bank, change this line. banks of sounds also included at: http://www.smwcentral.net/?p=thread&id=6665
    BRA Return
Stand:            ;you should also delete this line and all after this(excluding Reset: and lines after that) if you don't want to show poses
    LDA #$04      ;to change 2nd pose, change this. full list of poses in documents section of smwcentral.net
    STA $13E0     ;don't change if you want pose. if you don't want to show any pose, delete this line and the one above this
                  ;(to slow feet)Change this to:LDA $0660(or you're current flutter jump indicator)
                  ;(to slow feet)Modify this line to be double + 1 of [!] for the CMP #$...(also put CMP #$)
                  ;(to slow feet)Change this line to say:BCC Return
    DEC $0660     ;(to slow feet)Change this line into:LDA #$01
                  ;(to slow feet)Change this line into:STA $0660(or you're current flutter jump indicator)
    BRA Return
Reset:
    STZ $0660
    BRA Return
Carry:
    LDA $0660     ;same as above
    CMP #$02
    BCS Run
    LDA #$08
    STA $13E0
    INC $0660
    BRA Return
Run:
    LDA #$07
    STA $13E0
    DEC $0660
    BRA Return
Return:
        LDA $0DBE ;Don't mess with this part of code
        INC A
    RTL

%RATS_end(0)