header
lorom

;;;;;;;;;;;;;;;;;;;;;;;
; Init Timer Platform
;;;;;;;;;;;;;;;;;;;;;;;
org $018326

NOP                    ; \ 2 bytes...
NOP                    ; / we don't need.
LDA $E4,x              ; \ Load init X pos
LSR                    ;  |
LSR                    ;  |
LSR                    ;  | Divide by 16
LSR                    ;  |
AND #$03               ;  | 00 - 03
JSL MainRt             ;  | Go to main routine
RTS                    ; / Return

;;;;;;;;;;;;;;;;;;;;;;
; JSL!
;;;;;;;;;;;;;;;;;;;;;;
org $37B000              ; POINT TO FREESPACE!!!!

!RATS = Ending-TimeTable ; DO NOT REMOVE.

db "STAR"                ; Do not remove...
dw !RATS-$01             ; if you want the RATS tag...
dw !RATS-$01^$FFFF       ; to be there.

TimeTable:
db $3F
db $7F
db $BF
db $FF

MainRt:
PHX                      ; Preserve X
TAX                      ; Initial X pos into X index
LDA TimeTable,x          ; Load amount of time to stand on sprite
PLX                      ; Pull X
STA $1570,x              ; Store into timer.
RTL                      ; Return

Ending: