;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Lose Yoshi Routine                                                                   ;;
;; Patch version by Chdata								;;
;; This routine will cause Mario to lose Yoshi as if hit by an enemy                    ;;
;; By SMWEdit/Edit1754                                                                  ;;
;; Based off code starting at $02:A469 SNES ($01:2669 PC)                               ;;
;; Credit SMWEdit/Edit1754, not me							;;
;; Although you still can credit me if you want
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;How to make a custom block that makes you lose yoshi...				;;
;;[JMPS here]										;;
;;MarioTouch:										;;
;;JSL !Freespace + 8 (hex)								;;
;;OtherTouch:										;;
;;RTL											;;
;;And make it act like 25								;;
;;If you know how, you can even play a message or something.				;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!FREESPACEORZ = $168000	;POINT TO FREESPACE OR ELSE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

header
lorom
org !FREESPACEORZ 			;Free Space
db "STAR"				;\
dw MainEnd-MainStart-$01		; |RATS tag so this doesn't get overwritten
dw MainEnd-MainStart-$01^$FFFF		;/
MainStart:
LOSEYOSHI:
PHA			; back up A
LDA $187A		; \ if not riding Yoshi
BEQ NOYOSHI		; / skip over routine
PHX			; back up X (sprite index)
PHY			; back up Y
LDX $18E2		; Yoshi sprite index +1, would be zero if no Yoshi
LDA #$10		;
STA $163D,x		;
LDA #$03		; \ turn off
STA $1DFA		; / Yoshi drums
LDA #$13		; \ play lose-Yoshi
STA $1DFC		; / sound effect
LDA #$02		; \ set Yoshi to
STA $C1,x		; / running-away state
STZ $187A		; reset riding Yoshi flag
STZ $0DC1		; make sure Mario can't carry yoshi over levels
LDA #$C0		; \ make Mario
STA $7D			; / jump upwards
STZ $7B			; no X movement
LDY $157B,x		; \
PHX			;  | set Yoshi's
TYX			;  | running-away
LDA SPEED,x		;  | X speed ;$02A4B3 is what SMWEdit used. It was kinda slow.
PLX			;  |
STA $B5,x		; /
STZ $1593,x		;
STZ $151B,x		;
STZ $18AE		;
LDA #$30		; \ Mario invincible
STA $1497		; / timer
PLY			; restore Y
PLX			; restore X (sprite index)
NOYOSHI:
PLA			; restore A
RTL
SPEED: db $B0,$B0	;This is Yoshi's X speed table. It is currently Bobo... bo bobo bo!!!
; Hi			;Only use negative values (80-FF) (I think that's negative, please tell me if I'm wrong.)
; I			;Because using anything else makes him run to the right instead of left... unless you want him to.
; Am			;Closer to FF is slower (to the left movement)
; Useless		;Closer to 80 is faster left movement
; Empty			;7F is for a fast speed moving to the right
; Space			:Closer to 00 is slower
MainEnd:
print "I'm psychic, I knew that you would patch this."
print "-Chdata-"