;Message Box Recoding
;By: Chdata/Fakescaper
;Credit Chdata or be doomed, because this is one of his most useful patches and was confusing to make

header
lorom

!FREESPACE = $958000

!FreeRAMLevelASM = $010B	;Levelnum.ips
!NewNumber = $010D		;Extra overworld level ram (Message box trigger)
!YouHiTheBoxFlag = $62		;Will be non zero when you hit a message box. See below for details
!MessageFromSublevelFlag = $63	;If non-zero, use a different message box message show method lolwut
				;Basically if you want to use the new message box method, store a value above zero here.

org $05D8B9			;Levelnum.ips by BMF
JSL Levelnummain		;Levelnum.ips
org $05D89B			;Extra Overworld Message Box RAM (8-Bit/$13BF backup by Imamelia)
JSL Messain			;Extra Overworld Message Box RAM [AKA - 0-24 is normal message but 25 = 100's message etc)
org $038D7D			;Message Boxing
JSL MessageFix			;Message Boxing
NOP				;Message Boxing
org $038D8F			;Message Boxing ;Add a flag for when you hit info boxes
JSL YouHitABOX			;Message Boxing ;If you hit a box playing message one, it becomes #$01, if you hit one that plays message two it becomes #$02. As soon as the message HDMA/code is finished though (about one second) it's STZ'd though.
org $05B18E			;Message Boxing	;05B16E press $15/$17 to end message boxes
JMP $DC46			;Message Boxing ;JMP $B299 overwritten
org $05DC46			;Message Boxing ;(Freespace in bank #$05)
JML EndBoxTrigger		;Message Boxing ;Note: Notice the jump jumps to the last 2 bytes in the bank #$05 freespace

org !FREESPACE
db "STAR"
dw Endcode-Startcode
dw Endcode-Startcode^#$FFFF

Startcode:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Extra Overworld Message Box RAM		;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Messain:
LDA $7ED000,x			;hijacked code		; take the overworld level number...
STA !NewNumber			;and store it to our new RAM address
RTL				;(it will still store to $13BF after returning from the JSL)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Extra Overworld Message Box RAM		;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Levelnum.ips					;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Levelnummain:
.StoreLevelNum
LDA $0E
STA !FreeRAMLevelASM
ASL
CLC
RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Levelnum.ips					;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Message Boxing				;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MessageFix:
LDA #$22			;SFX
STA $1DFC			;(Code restoration)
LDA !MessageFromSublevelFlag	;If non-zero, use the message number from the current sublevel and not first sublevel entered on ow
BNE .UseNotTheNorm		;If zero, use translevel number
RTL

.UseNotTheNorm			;This code makes it so you play the message from the current sublevel, not translevel OW number
REP #$20
LDA $010B
CMP #$0101
BCS .Over9000			;If 101 or moar do something else
CMP #$0025			;Also 25-100 doesn't work either, so if it's one of those use the translevel number instead
BCS .nota

SEP #$20			;This code is reached if your in a normal level which is #$24 or less
STA $13BF			;And it stores it to the translevel number ram which is restored
.not				;After the message appears so screen exits aren't screwed
RTL				;#$25 = level 101

.nota				;This code is reached if it's an invalid translevel number
SEP #$20			;aka 25-100 and 13C+ don't have translevel numbers
RTL

.Over9000
CMP #$013C			;Level 13C+ is invalid so skip that
BCS .nota
SEC : SBC #$00DC
SEP #$20
STA $13BF
RTL

YouHitABOX:
INC A				;Important code restoration
STA $1426			;Trigger Message Box
STA !YouHiTheBoxFlag		;Will be non zero if you hit a box, and in addition to that will show what message you hit.
;LDA !YouHiTheBoxFlag		;
;STA $0ef9			;Varification that this really works
RTL

EndBoxTrigger:			;Plays when the message box HDMA/layer 3 upload finishes (about one second after the box appears)
STZ !YouHiTheBoxFlag		;STZ the flag that becomes the message number when you hit the info box sprite from below
LDA !NewNumber			;Restore the translevel number
STA $13BF			;Because if you don't screen exits will get screwed
;LDA !YouHiTheBoxFlag		;BTW that will enable you to change $13BF all you want for message box stuff, without needing to restore it in levelASM or something like that
;STA $0ef9			;For my own purposes I added another ram address that the translevel number is stored too.
JML $05B299			;Return/Code restoration
Endcode:

print "I'm psychic, I knew that you would patch this."
print "-Chdata-"