; Minor extended sprite tool
; By: HuFlungDu
; I created this as a joke no one but me understands, but on the offchance that
; someone can find some usefulness in this, here it is. I'm too lazy to write out
; a useful description, this will allow you to insert custom minor extended sprites into your ROM
; which act basically like cluster sprites really, except they can't interact with anything
; (unless you code them to I suppuse, but that's a bit much) That's all. No need for credit.


!Freespace = $138000

header
lorom

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

;Hijack
org $028B6E
	JSL StartPointers
	NOP
	NOP
;End all the normal routines with an RTL, since we will be using JSLs instead of JSRs
org $02902C
	RTL
org $028F2A
	RTL
org $028F8A
	RTL
org $028ECB
	RTL
org $028F86
	RTL
org $028E75
	RTL
org $028D65
	RTL
org $028DD6
	RTL
org $028E79
	RTL
org $028D41
	RTL
org $028C3A
	RTL
org $028C60
	RTL
org $028C69
	RTL
	
org !Freespace
%RATS_start(0)
StartPointers:
	STX $1698			;Restore Code
	REP #$20			;\This is my super neat way of
	PHX					;|jumping somewhere from a table
	ASL					;|without using SMWs built in one
	TAX					;|(and making it much easier for me)
	LDA.l Pointers,x	;|Basically you load the labels
	DEC					;|indexed by the sprite number
	PLX					;|Decrease it by 1 due to the way RTS/L works
	PHA					;|Then push it onto the stack
	SEP #$20			;|
	LDX $1698			;|
	LDA $17F0,X			;|Then, when you RTS, it grabs the location
	RTS					;|I pushed earlier and "returns" there.
						;/(Actually it jumps, but it doesn't need to know that)


; Regular sprites. These just jump to the normal routines. Don't touch these.	
MinEx0:
JML $028B77
MinEx1:
JML $028F8B
MinEx2:
JML $028ED2
MinEx3:
JML $028E7E
MinEx4:
JML $028F2F
MinEx5:
JML $028ED2
MinEx6:
JML $028DDB
MinEx7:
JML $028D4F
MinEx8:
JML $028DDB
MinEx9:
JML $028DDB
MinExA:
JML $028CC4
MinExB:
JML $028C0F


;This is where the custom ones start
OAMIndex:                      	db $50,$54,$58,$5C,$60,$64,$68,$6C
                                db $70,$74,$78,$7C
MinExC:

					PHB					;\Normal bank changing you see in all
					PHK					;|sprites
					PLB					;/
					DEC $1850,X         ;\Decrease the amount of time the sprite has left
					LDA $1850,X         ;|And kill it if so required    
					AND #$3F            ;|    
					BEQ KillSprite    	;/
					PHB					;\Because there is no JSLable
					LDA #$02			;|function for updating minor extended
					PHA					;|sprites Y/X  pos based on speed, it needs
					PLB					;|to be done like this
					JSL UpdateYPos	 	;|
					JSL UpdateXPos		;|	
					PLB  				;/
					LDA #$05			;\Set it's Y speed
					STA $1820,x			;/
					LDY.w OAMIndex,x    ;\Grab it's OAM index based on it's sprite index
										;/(Much the same way as it is done in cluster sprites)
					LDA $17FC,X     	;\Get YPos relative to screen border        
					SEC                 ;|If it's off screen, kill it					
					SBC $1C    			;|(Trust me, you want that)
					CMP #$F0            ;|  
					BCS KillSprite      ;|   
					STA $0201,Y 		;/If it's not, set it's OAM Ypos
					LDA $1808,X         ;\Same as above, but think X instead of Y
					SEC                 ;|    
					SBC $1A    			;|
					CMP #$F8            ;|  
					BCS KillSprite      ;|   
					STA $0200,Y 		;/
					LDA #$08            ;\Set the tile to be used    
					STA $0202,Y  		;/
			        LDA $1850,X     	;\Get the XY flip set by the spawning routine
					AND #$C0            ;|Since the timer only uses the first 6 bits, you get
										;|the last two to decide it's flipping. Pretty
										;/engenious really. This is set in the spawning routine
					ORA #$0B   			;\This sets the palette number
					ORA $64        		;|Then ORAs for priority, etc.  
					ORA #$30
					STA $0203,Y  		;/Then store the property OAM
					TYA                 ;\Get the OAM index where it needs to
					LSR                 ;|be for setting tile size
					LSR                 ;|    
					TAY                 ;/    
					LDA #$00            ;\Then set tile size  
					STA $0420,Y    		;/
					PLB					;Get the bank number back
					RTL                 ; Return 


UpdateYPos:        
					REP #$20
					LDA #$8C5F
					PHA
					SEP #$20  
					JML $02B5C8
					UpdateXPos:        
					REP #$20
					LDA #$8C5F
					PHA
					SEP #$20  
					JML $02B5BC   
					KillSprite:
					STZ $17F0,x
					PLB
					RTL

MinExD:
MinExE:
MinExF:
MinEx10:
MinEx11:
MinEx12:
MinEx13:
MinEx14:
MinEx15:
MinEx16:
MinEx17:
MinEx18:
MinEx19:
MinEx1A:
MinEx1B:
MinEx1C:
MinEx1D:
MinEx1E:
MinEx1F:
MinEx20:
MinEx21:
MinEx22:
MinEx23:
MinEx24:
MinEx25:
MinEx26:
MinEx27:
MinEx28:
MinEx29:
MinEx2A:
MinEx2B:
MinEx2C:
MinEx2D:
MinEx2E:
MinEx2F:
MinEx30:
MinEx31:
MinEx32:
MinEx33:
MinEx34:
MinEx35:
MinEx36:
MinEx37:
MinEx38:
MinEx39:
MinEx3A:
MinEx3B:
MinEx3C:
MinEx3D:
MinEx3E:
MinEx3F:
MinEx40:
MinEx41:
MinEx42:
MinEx43:
MinEx44:
MinEx45:
MinEx46:
MinEx47:
MinEx48:
MinEx49:
MinEx4A:
MinEx4B:
MinEx4C:
MinEx4D:
MinEx4E:
MinEx4F:
MinEx50:
MinEx51:
MinEx52:
MinEx53:
MinEx54:
MinEx55:
MinEx56:
MinEx57:
MinEx58:
MinEx59:
MinEx5A:
MinEx5B:
MinEx5C:
MinEx5D:
MinEx5E:
MinEx5F:
MinEx60:
MinEx61:
MinEx62:
MinEx63:
MinEx64:
MinEx65:
MinEx66:
MinEx67:
MinEx68:
MinEx69:
MinEx6A:
MinEx6B:
MinEx6C:
MinEx6D:
MinEx6E:
MinEx6F:
MinEx70:
MinEx71:
MinEx72:
MinEx73:
MinEx74:
MinEx75:
MinEx76:
MinEx77:
MinEx78:
MinEx79:
MinEx7A:
MinEx7B:
MinEx7C:
MinEx7D:
MinEx7E:
MinEx7F:
MinEx80:
MinEx81:
MinEx82:
MinEx83:
MinEx84:
MinEx85:
MinEx86:
MinEx87:
MinEx88:
MinEx89:
MinEx8A:
MinEx8B:
MinEx8C:
MinEx8D:
MinEx8E:
MinEx8F:
MinEx90:
MinEx91:
MinEx92:
MinEx93:
MinEx94:
MinEx95:
MinEx96:
MinEx97:
MinEx98:
MinEx99:
MinEx9A:
MinEx9B:
MinEx9C:
MinEx9D:
MinEx9E:
MinEx9F:
MinExA0:
MinExA1:
MinExA2:
MinExA3:
MinExA4:
MinExA5:
MinExA6:
MinExA7:
MinExA8:
MinExA9:
MinExAA:
MinExAB:
MinExAC:
MinExAD:
MinExAE:
MinExAF:
MinExB0:
MinExB1:
MinExB2:
MinExB3:
MinExB4:
MinExB5:
MinExB6:
MinExB7:
MinExB8:
MinExB9:
MinExBA:
MinExBB:
MinExBC:
MinExBD:
MinExBE:
MinExBF:
MinExC0:
MinExC1:
MinExC2:
MinExC3:
MinExC4:
MinExC5:
MinExC6:
MinExC7:
MinExC8:
MinExC9:
MinExCA:
MinExCB:
MinExCC:
MinExCD:
MinExCE:
MinExCF:
MinExD0:
MinExD1:
MinExD2:
MinExD3:
MinExD4:
MinExD5:
MinExD6:
MinExD7:
MinExD8:
MinExD9:
MinExDA:
MinExDB:
MinExDC:
MinExDD:
MinExDE:
MinExDF:
MinExE0:
MinExE1:
MinExE2:
MinExE3:
MinExE4:
MinExE5:
MinExE6:
MinExE7:
MinExE8:
MinExE9:
MinExEA:
MinExEB:
MinExEC:
MinExED:
MinExEE:
MinExEF:
MinExF0:
MinExF1:
MinExF2:
MinExF3:
MinExF4:
MinExF5:
MinExF6:
MinExF7:
MinExF8:
MinExF9:
MinExFA:
MinExFB:
MinExFC:
MinExFD:
MinExFE:
MinExFF:
RTL
;Pointer table. Don't touch this unless for some reason you enjoy stuff breaking
;Or you know what you are doing.
Pointers:
dw MinEx0
dw MinEx1
dw MinEx2
dw MinEx3
dw MinEx4
dw MinEx5
dw MinEx6
dw MinEx7
dw MinEx8
dw MinEx9
dw MinExA
dw MinExB
dw MinExC
dw MinExD
dw MinExE
dw MinExF
dw MinEx10
dw MinEx11
dw MinEx12
dw MinEx13
dw MinEx14
dw MinEx15
dw MinEx16
dw MinEx17
dw MinEx18
dw MinEx19
dw MinEx1A
dw MinEx1B
dw MinEx1C
dw MinEx1D
dw MinEx1E
dw MinEx1F
dw MinEx20
dw MinEx21
dw MinEx22
dw MinEx23
dw MinEx24
dw MinEx25
dw MinEx26
dw MinEx27
dw MinEx28
dw MinEx29
dw MinEx2A
dw MinEx2B
dw MinEx2C
dw MinEx2D
dw MinEx2E
dw MinEx2F
dw MinEx30
dw MinEx31
dw MinEx32
dw MinEx33
dw MinEx34
dw MinEx35
dw MinEx36
dw MinEx37
dw MinEx38
dw MinEx39
dw MinEx3A
dw MinEx3B
dw MinEx3C
dw MinEx3D
dw MinEx3E
dw MinEx3F
dw MinEx40
dw MinEx41
dw MinEx42
dw MinEx43
dw MinEx44
dw MinEx45
dw MinEx46
dw MinEx47
dw MinEx48
dw MinEx49
dw MinEx4A
dw MinEx4B
dw MinEx4C
dw MinEx4D
dw MinEx4E
dw MinEx4F
dw MinEx50
dw MinEx51
dw MinEx52
dw MinEx53
dw MinEx54
dw MinEx55
dw MinEx56
dw MinEx57
dw MinEx58
dw MinEx59
dw MinEx5A
dw MinEx5B
dw MinEx5C
dw MinEx5D
dw MinEx5E
dw MinEx5F
dw MinEx60
dw MinEx61
dw MinEx62
dw MinEx63
dw MinEx64
dw MinEx65
dw MinEx66
dw MinEx67
dw MinEx68
dw MinEx69
dw MinEx6A
dw MinEx6B
dw MinEx6C
dw MinEx6D
dw MinEx6E
dw MinEx6F
dw MinEx70
dw MinEx71
dw MinEx72
dw MinEx73
dw MinEx74
dw MinEx75
dw MinEx76
dw MinEx77
dw MinEx78
dw MinEx79
dw MinEx7A
dw MinEx7B
dw MinEx7C
dw MinEx7D
dw MinEx7E
dw MinEx7F
dw MinEx80
dw MinEx81
dw MinEx82
dw MinEx83
dw MinEx84
dw MinEx85
dw MinEx86
dw MinEx87
dw MinEx88
dw MinEx89
dw MinEx8A
dw MinEx8B
dw MinEx8C
dw MinEx8D
dw MinEx8E
dw MinEx8F
dw MinEx90
dw MinEx91
dw MinEx92
dw MinEx93
dw MinEx94
dw MinEx95
dw MinEx96
dw MinEx97
dw MinEx98
dw MinEx99
dw MinEx9A
dw MinEx9B
dw MinEx9C
dw MinEx9D
dw MinEx9E
dw MinEx9F
dw MinExA0
dw MinExA1
dw MinExA2
dw MinExA3
dw MinExA4
dw MinExA5
dw MinExA6
dw MinExA7
dw MinExA8
dw MinExA9
dw MinExAA
dw MinExAB
dw MinExAC
dw MinExAD
dw MinExAE
dw MinExAF
dw MinExB0
dw MinExB1
dw MinExB2
dw MinExB3
dw MinExB4
dw MinExB5
dw MinExB6
dw MinExB7
dw MinExB8
dw MinExB9
dw MinExBA
dw MinExBB
dw MinExBC
dw MinExBD
dw MinExBE
dw MinExBF
dw MinExC0
dw MinExC1
dw MinExC2
dw MinExC3
dw MinExC4
dw MinExC5
dw MinExC6
dw MinExC7
dw MinExC8
dw MinExC9
dw MinExCA
dw MinExCB
dw MinExCC
dw MinExCD
dw MinExCE
dw MinExCF
dw MinExD0
dw MinExD1
dw MinExD2
dw MinExD3
dw MinExD4
dw MinExD5
dw MinExD6
dw MinExD7
dw MinExD8
dw MinExD9
dw MinExDA
dw MinExDB
dw MinExDC
dw MinExDD
dw MinExDE
dw MinExDF
dw MinExE0
dw MinExE1
dw MinExE2
dw MinExE3
dw MinExE4
dw MinExE5
dw MinExE6
dw MinExE7
dw MinExE8
dw MinExE9
dw MinExEA
dw MinExEB
dw MinExEC
dw MinExED
dw MinExEE
dw MinExEF
dw MinExF0
dw MinExF1
dw MinExF2
dw MinExF3
dw MinExF4
dw MinExF5
dw MinExF6
dw MinExF7
dw MinExF8
dw MinExF9
dw MinExFA
dw MinExFB
dw MinExFC
dw MinExFD
dw MinExFE
dw MinExFF
%RATS_end(0)