; ########################################################################
; #                                                                      #
; #  OW Speed Changer, more or less made by WhiteYoshiEgg                #
; #  (pretty much all the code is by carol, I just cleaned it up a lot)  #
; #                                                                      #
; ########################################################################


header
lorom

	; ###############
	; # DEFINITIONS #
	; ###############

	!Speed		= $01		;    $01 = twice     the    original    speed,
					;    $02 = three  times  the  original  speed,
					;    [...] $FF = 256 times the original speed.

					;    ($00   will  keep   the  original  speed,
					;    ruining the point of this patch.)


	!YoshiSpeed	= $01		;    Speed  to  use   while  riding  on  Yoshi
					;    (same values as above).





	; ############
	; # THE CODE #
	; ############

org $048244				;    Hijack Game Mode 0E ("On Overworld")
	autoclean JML ApplySpeed




freecode
reset bytes
print " Inserted at $",pc



ApplySpeed:

	LDY #!Speed			;    Load speed value into Y

	LDA $0DD6 : LSR #2 : TAX	; \
	LDA $0DBA,x			;  | If the player is on Yoshi,
	BEQ .noYoshi			;  | load the Yoshi speed value instead
	LDY #!YoshiSpeed		; /

.noYoshi


.loop	
	TYA				; \
	BEQ .return			;  |
					;  | Then all we need to do
	PHY				;  | is execute SMW's OW speed routine Y times.
	JSR .runSpeedRoutine		;  |
	PLY				;  | (Each iteration makes it go faster, of course.)
					;  |
	DEY				;  |
	BRA .loop			; /


.return
	LDX #$01			; \
	LDA $0DA6,x			;  | Restore the hijacked code and return
	JML $048249			; /
	
	


.runSpeedRoutine

	LDA $13D9			; \
	CMP #$04			;  |
	BNE ..return			;  | Don't do this if the player isn't walking,
	LDA $13D4			;  | the game is paused
	BNE ..return			;  | or the ground is shaking
	LDA $1BA0			;  |
	BNE ..return			; /

	PHK				; \
	PEA.w ..return-1		;  | Run SMW's OW speed routine
	PEA.w $048575-1			;  |
	JML $04945D			; /
..return
	RTS
	



