;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Defines
;;;;;;;;;;;;;;;;;;;;;;;;;;;;


!Freespace = $128000

!MainMap = $3E		; XYPPCCCT format
!YoshiIsland = $34
!SpecialWorld = $30
!BowsersValley = $37
!StarWorld = $38
!ForestofIllusion = $39
!VanillaDome = $3A

; The original value was $36 = 00110110

;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

org $048607
NOP
JML MeCode


org !Freespace

db "STAR"
dw MeCodeEnd-MeCode-$01
dw MeCodeEnd-MeCode-$01^$FFFF

MeCode:



LDA $0DD6
BEQ Mario
LDA $1F12
BRA Luigi
Mario:
LDA $1F11
Luigi:
BEQ Main
CMP #$01
BEQ Yoshi
CMP #$02
BEQ Dome
CMP #$03
BEQ Forest
CMP #$04
BEQ Bowser
CMP #$05
BEQ Special

LDA #!StarWorld
BRA Share

Special:
LDA #!SpecialWorld
BRA Share

Bowser:
LDA #!BowsersValley
BRA Share

Forest:
LDA #!ForestofIllusion
BRA Share

Dome:
LDA #!VanillaDome
BRA Share

Yoshi:
LDA #!YoshiIsland
BRA Share

Main:
LDA #!MainMap
Share:
STA $0203,x
JML $04860C

MeCodeEnd: