;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Seperate Luigi Jump-height (Xkas) - Fixed
;by Ice Man on 09/29/08
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom						;\ ROM is LoRom
	header						;/ and has a header
	
	org $8DC4					;\ Hack NMI 
	JSL Code					;/ routine
	NOP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Definitions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
	!Code_Location = $128000	;| Location of the main code
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Main Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org !Code_Location

Code:
	LDA #$02					;\ Restore previous
	STA $420B					;/ hacked code.

	LDA $0100					;\ Only execute this,
	CMP #$14					;| if the level mode is 14.
	BNE Return					;/ Otherwise return.
	
	LDA $0DB3					;\ Check for the current
	CMP #$01					;| player, if it is Luigi.
	BNE Return					;/ Otherwise return.
	
	LDA $7D						;\ 
	SEC							;| Apply new jump height
	SBC #$01					;| to Luigi.
	STA $7D						;/ 

	LDA #$FF					;\ Disable Spin Jump
	STA $0DAC					;/ on Controller 1

	LDA #$FC					;\ Fireball Speed
	STA $1745					;/ #1

	LDA #$FC					;\ Fireball Speed
	STA $1746					;/ #2
	
Return:
	RTL							;| Return