;Sonic-Styled Powerdown Patch by RPG Hacker

header
lorom


!freespace = $238200   ; < POINT TO FREE SPACE



org $00F5F8       ;\ Disable Item Box getting used when hurt
	nop #$4   ;/ 

org $00F600      ;\ Disable Powerup Losing when hurt
        nop #2   ;/

org $00D129	             ;\ Eliminate Powerdown Animation and jump to Flash Routine
	db $EA,$EA,$EA,$80   ;/

org $009E2C           ;\
        jml newgame   ; | Loading/starting a game from title screen
        nop #2        ;/

org $00F5D5       ;\ Custom Damage Routine
        jml hit   ;/

org $00F5B2               ;\ When falling into a hole or lava
	jsl customdeath   ;/

org $00F606               ;\ Jump to Custom Death Routine
        jml customdeath   ;/

org $00A0E6                ;\ Reset Powerup when you die
        jsl Resetpowerup   ;/



;;;;;;;;;;;;;;;;;
;MAIN CODE START;
;;;;;;;;;;;;;;;;;

                                    
org !freespace                       ;\
                                     ; |
	db "STAR"                    ; | RATS-Tag
	dw codeend-newgame           ; |
	dw codeend-newgame^#$FFFF    ;/



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Starting a new game/Loading a Game;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


        newgame:
        lda #$04
        sta $0DBE
        lda #$01
        sta $19
        lda #$00
	sta $7E0DBF
        sta $7EC100
        sta $7EC101
	ldx $0DB2
	stz $0DC1
  	jml $009E3A



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Custom Damage Handling and HP Setting;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


        hit:              ;\
        lda $7E0DBF       ; |
        ora $7EC100       ; | Jump to Death Routine if Coins equal Zero
        ora $7EC101       ; |
        cmp #$00          ; |
        beq customdeath   ;/


        lda #$00      ;\
	sta $7E0DBF   ; | Set Coins to Zero
        sta $7EC100   ; |
        sta $7EC101   ;/


        lda #$38    ;\ Play Hurt Sound
        sta $1DFC   ;/

        lda #$01    ;\ Set Powerup to Super Mario
        sta $19     ;/

        lda $0D9B        ;\
        cmp #$80         ; | Disable Knockback in Iggy/Larry Battles
        beq NoKnockback  ;/

        lda #$D7     ;\
        sta $7D      ; |
                     ; |
        lda $76      ; |
        bne other    ; |
                     ; |
        lda #$29     ; |
        sta $7B      ; |
        bra next     ; | Knockback Code
                     ; |
        other:       ; |
        lda #$D7     ; |
        sta $7B      ; |
                     ; |
        next:        ; |
                     ; |
        NoKnockback: ; |
        jml $00F5DD  ;/

        customdeath:    ;\
        lda #$00        ; |
	sta $7E0DBF     ; |
        sta $7EC100     ; |
        sta $7EC101     ; |
        lda #$90        ; |
        sta $7D         ; |
        lda #$09        ; |
        sta $1DFB       ; |
        lda #$FF        ; | Death Routine Disassembly
        sta $0DDA       ; |
        lda #$09        ; | 
        sta $71         ; |
        stz $140D       ; |
        lda #$30        ; |
        sta $1496       ; |
        sta $9D         ; |
        stz $1407       ; |
        stz $188A       ; |
        rtl             ;/

        Resetpowerup:   ;\
        lda #$01        ; |
        sta $19         ; |
        sta $0DB8       ; | Reset Powerup after Death
        lda #$03        ; |
        sta $44         ; |
        rtl             ;/


codeend:    ; RATS-Tag End
