@includefrom MinorExtendedSprites.asm

MinorExSprite0C:
		LDA	$9D
		BNE	.gfx
		LDA	$1850,x
		BEQ	.kill
		DEC	$1850,x
		LDA	$13
		AND	#$03
		BEQ	.gfx
		JSR	MinorExUpdateGravity
.gfx		LDA	$028B78,x
		TAY	
		LDA	$1808,x
		SEC	
		SBC	$1A
		STA	$0200,y
		LDA	$18EA,x
		SBC	$1B
		BNE	.kill
		LDA	$1814,x
		SBC	$1D
		BNE	.next
.next		LDA	$17FC,x
		SEC	
		SBC	$1C
		CMP	#$F0
		BCS	.kill
		STA	$0201,y
		LDA	$14
		LSR	#2
		AND	#$07
		TAX	
		LDA.w	shine,x
		STA	$0202,y
		LDA	#!Props
		ORA	$64
		STA	$0203,y
		LDX	$1698
		TYA	
		LSR	#2
		TAY	
		LDA	#!Size
		STA	$0420,y
		RTL	
.kill		STZ	$17F0,x
.rtl		RTL
shine:		db !LargeShine,!MediumShine,!SmallShine,!MediumShine
		db !SmallShine,!LargeShine,!MediumShine,!SmallShine

MinorExSprite0D:
	;RTL
MinorExSprite0E:
	;RTL
MinorExSprite0F:
	RTL

MinorExUpdateGravity:
		JSR	MinorExUpdateYPos
		LDY	#$00
		LDA	$1820,x
		BPL	.down
		CMP	#$E8
		BCS	.down
		LDA	#$E8
.down		LDA	$1820,x
		CLC	
		ADC.w	data019030,y
		STA	$1820,x
		BMI	.next
		CMP.w	data01902E,y
		BCC	.next
		LDA	data01902E,y
		STA	$1820,x
.next		LDA	$182C,x
		PHA	
		ASL	
		ROR	$182C,x
		LDA	$182C,x
		PHA	
		STA	$00
		ASL	
		ROR	$00
		PLA	
		ADC	$00
		STA	$182C,x
		JSR	MinorExUpdateXPos
		PLA	
		STA	$182C,x
		RTS
MinorExUpdateXPos:
		LDA	$182C,x
		ASL	#4
		CLC	
		ADC	$1844,x
		STA	$1844,x
		PHP	
		LDA	$182C,x
		LSR	#4
		CMP	#$08
		BCC	$02
		ORA	#$F0
		PLP	
		ADC	$1808,x
		STA	$1808,x
		RTS	
MinorExUpdateYPos:
		LDA	$1820,x
		ASL	#4
		CLC	
		ADC	$1838,x
		STA	$1838,x
		PHP	
		LDA	$1820,x
		LSR	#4
		CMP	#$08
		BCC	$02
		ORA	#$F0
		PLP	
		ADC	$17FC,x
		STA	$17FC,x
		RTS	
data01902E:	db $40,$10
data019030:	db $03,$01