;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Super Mario Galaxy Spin
; By Yoshiownsu. 
; Help by Klopenator.
; 
; When you press L you will spin kinda like in Super Mario Galaxy. The original code is from Smallhackers L/R Hook Code.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;CHANGE THIS ADDRESS TO A FREE SECTION OF THE ROM!
!freeSpace = $0FEF90

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $00D068 
RTS 
NOP 
NOP 
NOP

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Disable L/R scrolling
org $00CDF6
    BRA lrSkip
    
org $00CE49
lrSkip:

;Hijack the status bar routine
org $008F49
	JSL NewRoutine

org !freeSpace
%RATS_start(0)

NewRoutine:
    LDA $18
    AND #$20
    BNE buttonL
    LDA $18
    AND #$10
    BEQ Return
    LDA $17
    AND #$20
    BNE Return
    
    ;INSERT R BUTTON CODE HERE
    ;Use "BRA Return" instead of RTL
    
    BRA Return
buttonL:
    LDA $17
    AND #$10
    BNE Return
    
    ;INSERT L BUTTON CODE HERE
    ;LDA $73
ORA $187A
ORA $140D
BNE Return
LDA #$12
STA $14A6   
LDA #$04
STA $1DFC
    
Return:
	LDA $0DBE
	INC A 
    RTL

%RATS_end(0)