header
lorom

!FreeSpace = $148000 ;Point this at some free space.

!ScreenNumber = $01
!FGOffset = $1C
!BGVertScroll = $20


;Hijack the appropriate location.
;This function expects Y to be loaded with $1414 when it returns.
org $05DA01
JSL Main
NOP
NOP

org !FreeSpace

VertBGScrollFixStart:

!VertBGScrollFixSize = VertBGScrollFixEnd-VertBGScrollFixStart

db "STAR"		; Write RATS tag
dw !VertBGScrollFixSize-$01
dw !VertBGScrollFixSize-$01^$FFFF

; This routine starts off in 16-bit mode for the indexes, 8-bit for accumulator.
; And it expects to leave that way too.
; Y can be played with as needed.
Main:
	LDA $01					;\ Required. Part of the original code.
	STA $97					;| Also required by us, as $01 has the screen number in it.
	STA $1D					;/
	
	PHA						;Preserve A for the moment.
	PHP						;Preserve the nvmxdizc register.
	
;Check the scroll speed. If it is not set as slow, exit.
	LDA $1414				;\ Check the BG vertical scroll speed.
	CMP #$03				;| If it is not set to slow, which is 0x03,
	BEQ DoFix				;| then don't do our fix.
	JMP Exit				;/
	
;The initial FG position screen is a combination of the screen number and the FG offset.
;The screen number is in the high byte, and the FG offset is in the low byte.
;I take this 16-bit number and divide by 8 (slow scrolling is 1 BG pixel for every 32 FG pixels,
; but the BG initial position is 4x the pixel offset. So we just divide by 8).
;Thus giving the proper BG offset.
DoFix:
	LDA !ScreenNumber
	XBA
	LDA !FGOffset
	REP #$20
	LSR
	LSR
	LSR
	STA !BGVertScroll
	SEP #$20

;Restore A and leave.
Exit:
	PLP
	PLA
	RTL

VertBGScrollFixEnd:
