;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; YI cloud (Block portion)
;; by Sonikku
;; this sprite should be placed in the same X and Y position of YICloud.asm. It will determine
;; which sprite, whether normal or custom, should be spawned by the sprite, before disappearing.
;; This method is much more efficient if you want to save sprite slots.
;; Set to act like any tile, but tile 25 is most preferred.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!Sprite = $79	; Change this to the sprite value to generate.
!YICloud = $00	; Change this to the sprite value for YICloud.cfg.

JMP Return
JMP Return
JMP Return
JMP Sprite
JMP Sprite
JMP Return
JMP Return
JMP Return
JMP Return
JMP Return

Sprite:	LDA $7FAB10,x
	AND #$08
	BEQ Return
	LDA $7FAB9E,x
	CMP #!YICloud
	BNE Return
	LDA #$00	; is sprite custom? #$00 for no, #$01 for yes
	STA $1594,x
	LDA #!Sprite
	STA $151C,x
	LDA #$08	; sprite status
	STA $157C,x
	;LDA #$02	; \ Number of stars to generate - 1.
	;STA $1534,x	; / Uncomment these lines if you're generating HealthStar.cfg.
	PHP
	LDA $0C
	STA $98
	LDA $0D
	STA $99
	LDA $0A
	STA $9A
	LDA $0B
	STA $9B
	LDA $0F
	PHA
	LDA #$02
	STA $9C
	JSL $00BEB0
	PLA
	STA $0F
	PLP
Return:	RTL