!ROM_Freespace = $258000	;Freespace. Important!
!RAM_Bank = $1DF9				;Which bank to use for sound effect?
!Value_Sound = $1C				;Which sound to use for sound effect?
!Value_Message = $03			;Which message to use? $01 -> Level Message 1; $02 -> Level Message 2; $03 - Yoshi Thanks Message

header		;ROM has a header...
lorom		;And is LoROM.

reset bytes

org $00F358						;Sound effect part of Yoshi Coin collection subroutine
JSL RAMCheck					;Replace with JSL RAMCheck. Add "|$800000" after "JSL RAMCheck" if your hack uses FastROM mapping.
NOP #1							;Clear out 1 byte to prevent crashing

org !ROM_Freespace	;Jump to freespace.

db "STAR"                        				;\ 
dw End-RAMCheck-$01           		; |RATS tag
dw End-RAMCheck-$01^$FFFF     ;/

RAMCheck:
LDA #!Value_Sound		;Play sound effect and return
STA !RAM_Bank

LDA $1F2B				;Load flag
BEQ Show					;If 00, show message
RTL

Show:
LDA #!Value_Message	;Load message number
STA $1426
INC $1F2B					;Set the "collected one yoshi coin" flag
RTL
End:

print "Inserted ",bytes," bytes at specified freespace."
