!Freespace	= $168000	;FREESPACE
!Level		= #$0105	;Level number for BBB to use palettes defined in table below

header
lorom

org $838254
	JSL LoadPal

!lvlram = $010B			;Levelnum.ips
org $85D8B9			;
	JSR lvlnum		;
org $85DC46			;
lvlnum:				;
	LDA $0E			;
	STA !lvlram		;
	ASL A			;
	RTS			;

org !Freespace|$800000
db "STAR"
dw End-LoadPal-1
dw End-LoadPal-1^-1

LoadPal:			;8-bit AXY
	REP #$20		;16-bit A 8-bit XY
	LDA $010B		;lvlnum
	CMP !Level		;Level number that BBB has a different palette
	SEP #$20		;8-bit AXY
	BNE Nrouter		;If not level, do vanilla routine
	;PHB : PHK : PLB	;iirc this is not needed with long loading, but if the palette doesn't load correctly and you're sure you're not just accidently using crap colors, uncomment this and the ;PLB below
	LDA.l BooBossPals,x	;
	;PLB			;Incase you don't know what uncomment means, remove the semicolon
	RTL			;
Nrouter:			;
	LDA.l $03B982,x		;
	RTL			;

BooBossPals:			;This table is the palettes to use for Big Boo Boss. You can use LM to find hex values for palettes.
	dw $7FFF,$0C63,$0000,$0C00	;Note: It only effects the first 8 colors, and not the second half of 8 colors
	dw $0C00,$0C00,$0C00,$0003	;I converted this table from db's to dw's for easier editing, but I may have messed up a vanilla colors somewhere. It shouldn't matter though, since you'll be editing this anyways

	dw $7FFF,$1CE7,$0000,$1C00
	dw $1C00,$1C20,$1C81,$0007

	dw $7FFF,$2D6B,$0000,$2C00
	dw $2C40,$2CA2,$2D05,$000B

	dw $7FFF,$3DEF,$0000,$3C60
	dw $3CC3,$3D26,$3D89,$000F

	dw $7FFF,$4E73,$0000,$4CE4
	dw $4D47,$4DAA,$4E0D,$1013

	dw $7FFF,$5EF7,$0000,$5D68
	dw $5DCB,$5E2E,$5E91,$2017

	dw $7FFF,$6F7B,$0000,$6DEC
	dw $6E4F,$6EB2,$6F15,$301B

	dw $7FFF,$7FFF,$0000,$7E70
	dw $7ED3,$7F36,$7F99,$401F
End: