;Debug Function Toggle by HyperHacker
;Enables and disables various debug functions in the ROM.
header
lorom

org $950B ;Boss Scene Select
	db $00 ;Disable
	;db $30 ;Enable

org $A248 ;Frame-by-Frame Advance/Slow-Motion
	db $12 ;Disable
	;db $00 ;Enable

org $A256 ;Adjust speed of Slow-Motion
	;db $0F ;Default

org $A25F ;Press Start to finish level
;doesn't seem to work. Would be redundant anyway.
	db $F0 ;Disable
	;db $D0 ;Enable

;The following two must be used together.
org $A268 ;Can exit any level with Start+Select, and finish it
	db $20 ;Disable
	;db $00 ;Enable
org $A273
	db $0A ;Disable
	;db $00 ;Enable

org $C576 ;Powerup Select
	db $80 ;Disable
	;db $F0 ;Enable

org $CC84 ;Free-Roaming Mode
	db $80 ;Disable
	;db $F0 ;Enable

org $E2D3 ;Infinite Star
	db $40 ;Disable
	;db $00 ;Enable

org $04824B ;Press Select on Overworld to Cycle Yoshi Colours
	db $80 ;Disable
	;db $F0 ;Enable

org $049136 ;Press Select at Yoshi's House on Overworld to Warp to Star World
	db $80 ;Disable
	;db $F0 ;Enable

org $049291 ;Can Walk on Unrevealed Overworld Paths (breaks Star World)
	db $EA, $EA, $EA ;Disable
	;db $4C, $AF, $92 ;Enable

org $00FFA0 ;CPU meter added by BMF's patch
	db $1E ;Disable
	;db $00 ;Enable