;----------
;FireAmmo Counter
;----------


!Freespace = $109734	;/ Area where the hack will get stored.
!Tile = $76		;\ Tilemap to use to indicate fire flower on the status bar. As of now, it's using a clock.
!Ram = $0111
!RamSram = $700400
!Pos = $0EF9		; Position to draw tilemaps.
!InitAmmo = $20		; Ammo to start the game with, decimal. Support for 100+ is not added (yet?).


;----------------
Header
LoROM
org $FFD8
db $03		; Expand SRAM.
org $9E2C
JSL GameLoad
NOP #2
org $8F7E
JSL CustHack
org $FEA8
JML FireBall
org $9BCC
JSL Save	
NOP #2
org !Freespace	
!CodeSize = Ending-Routine 	
db "STAR"			
dw !CodeSize-$01
dw !CodeSize-$01^$FFFF
Routine:
;----------------
GameLoad:
	STA $0DBE
	STZ $0DBF
	LDX $010A
	CPX #$00
	BNE +
	LDA $70008C ; game 1 
	BRA +++
+
	CPX #$01
	BNE ++
	LDA $70011B ; game 2
	BRA +++
++
	LDA $7001AA ; game 3
+++
	CMP #$FF
	BNE +
-
	LDA #!InitAmmo
	STA !Ram
	RTL
+
	CMP #$00
	BEQ -
LoadData:
	LDA !RamSram,x
	STA !Ram
	RTL

CustHack:
	STX $0F13
	STA $0F14
	LDA $19		;\
	CMP #$03	; | Comment these 3 lines to draw tilemaps all the time.
	BNE +		;/
	LDA #!Tile
	STA !Pos
	LDA #$26
	STA !Pos+1
	LDA !Ram
	JSR HexDec
	STX !Pos+2
	STA !Pos+3
	RTL
+
	LDX #$03
-
	LDA #$FC ; Clear out tilemap..
	STA !Pos,x ; If not having a flower.
	DEX
	BPL -	
	RTL

HexDec:
	LDX #$00
-
	CMP #$0A
	BCC +
	SBC #$0A
	INX
	BRA -

+
	RTS

FireBall:
	LDA !Ram
	BEQ +
	LDX #$09
-
	LDA $170B,x
	BEQ ++
	DEX
	CPX #$07
	BNE -
	BRA +++
+
	LDA #$2A	;/
	STA $1DFC	;\ Comment to filter out incorrect sound.
+++
	JML $00FEB4
++
	LDA !Ram
	DEC A
	STA !Ram
	JML $00FEB4+1

Save:
	LDA $010A
	;ASL A
	TAX
	LDA !Ram	;\
	STA !RamSram,x	;/ Push RAM status.. to SRAM.
	LDX $010A
	LDA $009CCB,x
	RTL
Ending: