;Green Berry Eaten FX Hijack
;By: Chdata/Fakescaper
;I made this as customizeable as possible
;By default it changes nothing

!Freespace = $168000	;

!SFX       = #$29	;Sound FX number
!SoundRAM  = $1DFC	;Sound FX RAM address
!TimeDigit = $0F32	;Default is the tens digit. It should not go over #$0A or it'll show letters.
!AmounToAd = #$02	;How much to add to that digit

			;Of course you can do many other things with this. For example you could try making eating an apple kill the player.

header
lorom

org $01F0FD
JSL ADifferentTime
BRA NotNop
NOP #17
NotNop:

org !Freespace
db "STAR"
dw TimeStop-ADifferentTime-#01
dw TimeStop-ADifferentTime-#01^#65535

ADifferentTime:
LDA !SFX
STA !SoundRAM
LDA !TimeDigit
CLC
ADC !AmounToAd
CMP #$0A
BCC CODE_01F111
BRA Endo
SBC #$0A
INC !TimeDigit-1
CODE_01F111:
STA !TimeDigit
Endo:
RTL
TimeStop:

;Below are example codes I made for what you can do with this. Commented out, uncomment these and comment out the code above to use them.

;IncreaseTimeByOneSecond:
;ADifferentTime:
;LDA !SFX
;STA !SoundRAM
;LDA $0F33
;CLC
;ADC !AmounToAd
;CMP #$0A
;BCC CODE_01F111
;BRA Endo
;CODE_01F111:
;STA $0F33
;Endo:
;RTL
;TimeStop:

;IncreaseHundreDigit:
;ADifferentTime:
;LDA !SFX
;STA !SoundRAM
;LDA $0F31		;Hundreds Digit
;CLC
;ADC #$01		;Add one minute.
;CMP #$0A
;BCC ActuallyDont	;Don't add a minute if you're at 9 minutes already
;STA !TimeDigit
;ActuallyDont:
;RTL
;TimeStop:

;BadApple:		;Note: This glitches out if Yoshi eats it directly.
;ADifferentTime:
;LDA #$2A
;STA $1DFC
;JSL $00F606
;LDA #$06
;STA $0F31
;STA $0F32
;STA $0F33
;RTL
;TimeStop: