;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Mario knockback
; By Kevinskie555/Smallhacker
; 
; Knocks Mario up/backwards when hurt
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;CHANGE THIS ADDRESS TO A FREE SECTION OF THE ROM!
!freeSpace = $438000

;Speed to be knocked back with
;(Second value is the same, but negative)
!knockSpeed1 = $40
!knockSpeed2 = $C0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Hijack the hurt routine
org $00F5D5
    JML NewRoutine

; Remove the "Mario is shrinking" animation
; and replace it with setting the flash
; invincibility manually
org $00F5FC
    JSL MarioFlash

org !freeSpace
%RATS_start(0)

NewRoutine:
   
    LDA #!knockSpeed2
    STA $7D
    
    LDA $76
    BNE Other
    
    LDA #!knockSpeed1
    STA $7B
    
Other:
    LDA #!knockSpeed2
    STA $7B

    
MarioFlash:
	LDA #$7F
	STA $1497
	RTL

%RATS_end(0)