;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Based on:
; LR Hook - Version 1.1
; By Smallhacker
; 
; Disables L/R and prepares them to be used for other stuff
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;CHANGE THIS ADDRESS TO A FREE SECTION OF THE ROM!
!freeSpace = $0FEF90

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Disable L/R scrolling
org $00CDF6
    BRA lrSkip
    
org $00CE49
lrSkip:

;Hijack the status bar routine
org $008F49
	JSL NewRoutine

org !freeSpace
%RATS_start(0)

NewRoutine:
    LDA $18
    AND #$20
    BNE buttonL
    LDA $18
    AND #$10
    BEQ Return
    LDA $17
    AND #$20
    BNE Return

    JMP GetInfo
    
    ;INSERT R BUTTON CODE HERE
    ;Use "BRA Return" instead of RTL
    
    ;BRA Return
buttonL:
    LDA $17
    AND #$10
    BNE Return
    
GetInfo:
	LDA $5B
	BEQ Horz
	LDX $97
	BRA Setup
Horz:	LDX $95
Setup:	LDA $13BF
	PHA
	CMP #$25	
	BCC +
	CLC	
	ADC #$DC
+	STA $19B8,x
	PLA
	CMP #$25
	BCS Done
	LDA #$00
	BRA Finish
Done:	LDA #$01
Finish:	ORA #$04
	STA $19D8,x
	LDA #$06
	STA $71
	STZ $88
	STZ $89
    	;LDA #$22	;\
	;STA $1DF9	;/ Uncomment for some sound.
Return:
	LDA $0DBE
	INC A 
    RTL

%RATS_end(0)