;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;v;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;This patch shows the current level number as appears in Lunar Magic	;;
;;Will write over the score though					;;
;;I also included some code that disables the score			;;
;;By: Chdata/Fakescaper							;;
;;Credit Chdata								;;
;;I mainly made this for organizational purposes			;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
!FREESPACE	= $A78000	;POINT TO AN UNUSED SNES LOROM OFFSET
!LevelNumRAM	= $010B		;No need to change really
!StatusBarSTRT	= $0F29,x	;Where this gets written onto the status bar, see 1024's diagram

header
lorom

org $8F84			;Main hijack of this patch
JSR.l MainLN			;It was required to hijack the status bar
NOP				;Need to NOP so we don't crash the game
org $05D8B9			;This
JSR Levelnummain		;is
org $05DC46			;the
Levelnummain:			;levelnum.ips
LDA $0E				;disassembley.
STA !LevelNumRAM		;It
ASL A				;is
RTS				;required
org $028766			;Disable Score part one
BRA NoNOP			;
NOP				;
NoNOP:				;
org $02AE21			;Disable Score part two
LDA $0F35,x			;
ADC $AD89,y			;
BRA .NotNOP			;
REP 4 : NOP			;
.NotNOP				;
org $05CEF9			;Disable Score part three
BRA .SkipNOPS			;
REP 10 : NOP			;
.SkipNOPS			;

org !FREESPACE
db "STAR"
dw EndcodeLN-StartCodeLN
dw EndcodeLN-StartCodeLN^$FFFF

StartCodeLN:
MainLN_LVL:			;To make it say "LVL0105" etc apply the changes shown in these comments
db $15,$1F,$15,$FC		;db $15,$1F,$15

MainLN:
SEP #$20	;Code Restoration
PHA		;\
PHY		; |
PHX		; |Preserve "everything"
PHB		; |I probably really only needed to use PHA PHX PLX PLA but w/e
PHK		; |
PLB		;/

.WriteLVL
LDX #$03			;LDX #$02

.LVLoop
LDA .LVL,x
STA $0F29,x
DEX
BPL .LVLoop

REP #$20
LDX #$04			;LDX #$03
;LDA !LevelNumRAM
;REP 12 : LSR
;JSR .storeL3

LDA !LevelNumRAM
REP 8 : LSR
JSR .storeL3

LDA !LevelNumRAM
REP 4 : LSR
JSR .storeL3

LDA !LevelNumRAM
JSR .storeL3

SEP #$20
PLB		;\
PLX 		; |Recover "everything"
PLY		; |
PLA		;/
LDX $0DB3	;Code Restoration
RTL

.storeL3
AND #$000F
SEP #$20
STA $0F29,x
REP #$20
INX
RTS

EndcodeLN:
print "I'm psychic, I knew that you would patch this."
print "-Chdata-"