;$0EF9-$0F19 is used
;the score still uses part of $0F1A-$0F2F

!statusloc = $0EF9	;do not change
!bgcolor = $0000	;status bar background color (default=black)

;below = location of counters in status bar. only change the added value
!player		= !statusloc+$1
!time		= !statusloc+$17
!lives		= !statusloc+$3
!itembox	= !statusloc+$12
!coins		= !statusloc+$1D
!yicoins	= !statusloc+$B
!bonus		= !statusloc+$8

header : lorom

org $008292
LDY #$09		;status bar scanline length

org $0082A4
autoclean JML PreStatusBar
NOP #2

org $00838F
autoclean JML PostStatusBar
NOP

org $008CFF
autoclean JML StatusHijack
NOP

org $008DAC
autoclean JML DrawStatusHijack
NOP

org $028052
db $78			;item box X drop ($78)

org $028060
db $09			;item box Y drop ($0F)

org $008E6F		;Time hijack
LDA $0F31
STA !time
LDA $0F32
STA !time+$1
LDA $0F33
STA !time+$2

org $008F55		;Lives hijack
STX !lives
STA !lives+$1

org $008F7E		;Coins hijack
STA !coins+$1
STX !coins

org $008F86
autoclean JML MiscCounters
NOP


freecode

PreStatusBar:		;status bar
LDA $0D9B
BNE +
LDA #$00 : STA $2111	;static layer 3
LDA #$00 : STA $2111
LDA #$FF : STA $2112
LDA #$01 : STA $2112
LDA #$04 : STA $212C	;layer 3 on main+sub
STZ $212E
STZ $2130
STZ $2131
STZ $2121
LDA.b #!bgcolor : STA $2122
LDA.b #!bgcolor>>8 : STA $2122
LDA #$09 : STA $2105	;gfx mode 1 + layer 3 priority
JML $0082B0
+
STZ $2111
STZ $2111
STZ $2112
STZ $2112
JML $0082B0

PostStatusBar:		;normal
BIT $4212 : BVC $FB	;wait for h-blank
LDA #$80 : STA $2100	;f-blank the scanline
LDA $22 : STA $2111
LDA $23 : STA $2111
LDA $24 : STA $2112
LDA $25 : STA $2112
LDA $3E : STA $2105
LDA $0D9D : STA $212C	;main screen
STA $212E
LDA $0D9E : STA $212D	;sub screen
STA $212F
LDA $40 : STA $2131	;color math
LDA $44 : STA $2130
STZ $2121
STZ $2122 : STZ $2122	;color 0 back to black
BIT $4212 : BVC $FB	;wait for h-blank again
LDA $0DAE : STA $2100	;restore brightness
JML $0083B2


MiscCounters:
PHB : PHK : PLB

LDX $0DC2		;Item Box Item
LDA .statuspowerup,x
STA !itembox

LDX $0DB3
LDA .playertable,x	;Current Player
STA !player

LDA $0F48,x		;Bonus Stars
PHK
PEA.w .jslrtsreturn-1
PEA.w $0084CF-1
JML $009045
.jslrtsreturn
TXY : BNE +
LDX #$FC
+
STX !bonus
STA !bonus+$1

LDX #$00		;Yoshi Coins
LDA $1422
DEC A : STA $00
-
LDA #$2E		;full yoshi coin tile
LDY $00 : BPL +
LDA #$FC		;blank yoshi coin tile
+
STA !yicoins,x
DEC $00 : INX
CPX #$05 : BCC -	;# of yoshi coins needed to stop display

PLB : JML $008FF9

.statuspowerup
db $FC,$95,$97,$96,$28
;none, mushroom, flower, star, feather

.playertable
db $7C,$0B	;Mario tile, Luigi tile


;Status Bar upload routine

StatusHijack:
REP #$20
LDX #$80 : STX $2115
LDA #$5000 : STA $2116
LDA #$1900 : STA $4310
LDA.w #StatusPal : STA $4312
LDX.b #StatusPal>>16|$80 : STX $4314
LDA #$0020 : STA $4315
LDX #$02 : STX $420B

LDA.w #!statusloc : STA $2181
LDX #$7E : STX $2183
LDA #$8000 : STA $4310
LDA.w #StatusTiles : STA $4312
LDX.b #StatusTiles>>16|$80 : STX $4314
LDA #$0020 : STA $4315
LDX #$02 : STX $420B
SEP #$20
JML $008D8A

DrawStatusHijack:
REP #$20
LDX #$00 : STX $2115
LDA #$5000 : STA $2116
LDA #$1800 : STA $4310
LDA.w #!statusloc : STA $4312
LDX #$7E : STX $4314
LDA #$0020 : STA $4315
LDX #$02 : STX $420B
SEP #$20
JML $008DE6

StatusTiles:
db $FC
db $7C,$26,$27,$27		;lives
db $FC
db $64,$26,$27,$27		;bonus stars
db $FC
db $FC,$FC,$FC,$FC,$FC		;yoshi coins
db $FC
db $5B,$FC,$5C			;item box
db $FC
db $76,$77,$27,$27,$27		;time
db $FC
db $2E,$26,$27,$27		;coins
db $FC

StatusPal:
db $38
db $29,$38,$38,$38		;lives
db $38
db $28,$38,$38,$38		;bonus stars
db $38
db $3C,$3C,$3C,$3C,$3C		;yoshi coins
db $38
db $39,$28,$39			;item box
db $38
db $38,$38,$3C,$3C,$3C		;time
db $38
db $3C,$38,$38,$38		;coins
db $38