;Display Reserve item in OW
; patch for SMW. 
; notes: use asar. see readme.
; by zkip

lorom


org $00A169
	autoclean JML OWTakeOver

freecode
OWTakeOver:		;note: at this point it's safe to use vram
	PHB		; bank wrapper to make lda $xxxx,x not use garbage
	PHK		;
	PLB		;
	JSR UploadFeatherGFX
	LDA #$80	;high bit is set here so use of 16bit values
	STA $2115	;can be done to 2118
	REP #$20
	LDA #$5016	;vram address $5016
	STA $2116
	LDX #$00
.l
	LDA OWText,x
	STA $2118
	INX		;using word values so we increase it twice
	INX		;
	CPX #$10
	BNE .l

	LDA $0DBC	;we only need the low byte
	AND #$00FF	;
	ASL		;x2 because it's a word value
	TAX		;
	LDA OWicons,x
	STA $2118

	LDA #$395C	;the last ')'
	STA $2118
	SEP #$20


	PLB		;superrecoverymode go!
	LDA #$F0
	STA $3F
	JML $00A16D

; The following routine uploads a single 8x8 tile to VRAM.
;      DMA for only only 16 bytes :E
;
UploadFeatherGFX:
	REP #$10
	LDX.w #$4990		;Set VRAM pointer to $4990
	STX $2116
	LDA #$01
	STA $4310
	LDA #$18
	STA $4311
	LDX.w #FeatherGFX
	STX $4312
	PHK
	PLA
	STA $4314
	LDX.w #$0010
	STX $4315
	SEP #$10
	LDA #$02		;Enable DMA channel #1
	STA $420B
	RTS

OWText:
	dw $3911, $3944, $3952, $3944, $3951, $3955, $3944, $395B	;"Reserve("

;The following is the 16bit table of tiles to use for each value
; of $0DBC. Expand as you'd like. 
;
OWicons:
	dw $38FE, $3895, $3897, $3896, $3932


; The following is the 2BPP formatted GFX data for
;  the feather icon that gets uploaded to VRAM.
;
;   Note: Don't mess with this unless you know
;       what you are doing.
FeatherGFX:
	db $1F, $E0, $6F, $90, $57, $A8, $AB, $54
        db $D3, $2C, $E1, $1E, $F8, $07, $FC, $03
