;smb2 hi-jump

!jumpframes = $50	;# of frames needed to be fully charged
!jumpyspeed = $90	;basically, how high you can jump ($FF to $80 = upwards)

!chargesfx = $02	;sfx when you are fully charged (default: hit prize block)
!chargesfxbnk = $1DFC	;sound bank for sfx above

!jumpsfx = $01		;sfx when you hi-jump (default: regular jump)
!jumpsfxbnk = $1DFA	;sound bank for sfx above

!jumpram = $0E87	;flags. dont change
!jumpram2 = $0E88	;timer. dont change

hijump:
LDA $19
CMP #$02
BEQ .clear
LDA $71
CMP #$05
BCS .clear
LDA $74
ORA $75
ORA $1891
ORA $187A
ORA $1493
BNE .clear

LDA !jumpram
LSR
BNE .hijump
BCS .charge

.init
LDA #!jumpframes
STA !jumpram2
INC !jumpram

.charge
LDA $73
BEQ .clear
LDA $77
AND #$04
BEQ .clear
DEC !jumpram2
BNE .end
LDA #!chargesfx
STA !chargesfxbnk
INC !jumpram
BRA .end

.hijump
LDA $7B
BNE .clear
LDA #$02
STA $149B
LDA $16
AND #$80
BEQ .end
LDA #!jumpsfx
STA !jumpsfxbnk
LDA #!jumpyspeed
STA $7D
STZ !jumpram
BRA .end

.clear
STZ !jumpram
STZ !jumpram2

.end
RTS