header
lorom

macro comment()
;This is a trick to create multiline comments. I know it looks confusing, but I belive semicolons everywhere will be even more confusing.

If you want to add this fix to the disassembly, find the following lines (they're around line 193):

			AND #$01				; |
			BNE Return02EEA8			;/ return
			LDY #$00				;\ make Mario match the sprite's horizontal movement
			LDA $1491				; |

And change them to the following:

			AND #$01				; |
			BNE Return02EEA8			;/ return
LDA $14
CMP !Freeram
BEQ Return02EEA8
STA !Freeram
			LDY #$00				;\ make Mario match the sprite's horizontal movement
			LDA $1491				; |

Remember to add !Freeram = $57 (or another address if you changed it) around the start of the sprite code.

endmacro

!Freespace = $1FFFFF;CHANGE ME!!! The default WILL crash your ROM!
!Freeram = $57;This address may be cleared whenever you want,
;except when the sprite codes are running. When all sprite codes are done
;(or if Mario isn't on a skull raft), feel free to use it for anything. The default is cleared on level load.

org $02EE96
JML Main

org !Freespace
Main:
LDA $14
CMP !Freeram
BEQ DontMove
STA !Freeram

LDY #$00
LDA $1491
JML $02EE9B

DontMove:
JML $02EEA8