;don't patch this directly
;
;it's included when you patch owyicoin.asm
;
;you're free to edit though

PHB : PHK : PLB
JSR OWLives
JSR OWCoin
JSR OWScore
JSR OWPlayer
JSR OWTimer
PLB : RTS


OWLives:
LDA $0DBE
INC A
LDX #$00
-
CMP #$0A
BCC +
SBC #$0A
INX
BRA -
+
CLC : ADC #$22
STA $01
TXA
CLC : ADC #$22
CMP #$22
BNE +
LDA #$AE		;replace 0 with blank tile
+
STA $00

%vramwrite(#$00, #$1800, 588E, $0000, $7E, #$0002)
RTS


OWCoin:
LDA $0DBF			;current coin count
LDX #$00
-
CMP #$0A
BCC +
SBC #$0A
INX
BRA -
+
CLC : ADC #$22
STA $01
TXA
CLC : ADC #$22
CMP #$22
BNE +
LDA #$AE		;replace 0 with blank tile
+
STA $00

%vramwrite(#$00, #$1800, 5895, $0000, $7E, #$0002)
RTS


OWScore:
PHB : PHK : PLB

LDX $0DB3 : BEQ +
LDX #$03
+
LDA $0F34,x		;score low byte
STA $0C
LDA $0F35,x		;score middle byte
STA $0D
LDA $0F36,x		;score high byte
STA $0E
STZ $0F

LDX #$00
LDY #$00

PHA : PHA : PHA : PHA	;dont want to use free ram so we'll use the stack
LDA #$00 : PHA : PLB
-
SEP #$20		;below code was ripped & edited from $009012, minus the stack use
STZ $00,x
--
REP #$20
LDA $0C
SEC : SBC $8FFC,y
STA $03,s
LDA $0E
SBC $8FFA,y
STA $01,s
BCC +
LDA $03,s
STA $0C
LDA $01,s
STA $0E
SEP #$20
INC $00,x
BRA --
+
INX
INY #4
CPY #$18
BNE -
SEP #$20
PLA : PLA : PLA : PLA	;restore stack pointer

LDA $00
BNE +
LDA #$AE		;leading 0 becomes empty space
+
STA $00

LDX #$00
-
LDA $01,x
TAY
BNE +
LDA $00,x
CMP #$AE		;same here
BNE +
LDY #$AE		;"
+
TYA
STA $01,x
INX : CPX #$05 : BCC -

LDX #$05
-
LDA $00,x
CMP #$AE		;"
BEQ +
CLC : ADC #$22
+
STA $00,x
DEX : BPL -

%vramwrite(#$00, #$1800, 5874, $0000, $7E, #$0006)
PLB
RTS


OWPlayer:
LDX #$03 : LDY $0DB3
-
LDA .mario,x
CLC
ADC .luigi,y
STA $00,x
DEX : BPL -

%vramwrite(#$00, #$1800, 5889, $0000, $7E, #$0004)
RTS

.mario
db $DC,$DD,$DE,$DF
.luigi
db $00,$10


OWTimer:
LDA !east_timor : CLC : ADC #$22 : STA $01
LDA !east_timor+$1 : CLC : ADC #$22 : STA $00
%vramwrite(#$00, #$1800, 5859, $0000, $7E, #$0002)

LDA !east_timor+$2 : CLC : ADC #$22 : STA $01
LDA !east_timor+$3 : CLC : ADC #$22 : STA $00
%vramwrite(#$00, #$1800, 5856, $0000, $7E, #$0002)

LDA !east_timor+$4 : CLC : ADC #$22 : STA $01
LDA !east_timor+$5
BNE +
LDA #$AE
BRA ++
+
CLC : ADC #$22
++
STA $00
%vramwrite(#$00, #$1800, 5853, $0000, $7E, #$0002)

LDA !east_timor+$6 : CLC : ADC #$22 : STA $01
LDA !east_timor+$7
BNE +
LDA #$AE
BRA ++
+
CLC : ADC #$22
++
STA $00
%vramwrite(#$00, #$1800, 584C, $0000, $7E, #$0002)

LDA #$A4 : STA $00
LDA #$39 : STA $01
LDA $1F2E
CMP #!exitcounter
BCC +
LDA #$F8 : STA $00
LDA #$35 : STA $01
+
%vramwrite(#$80, #$1801, 5849, $0000, $7E, #$0002)

RTS