HEADER
LOROM

!freespace = $3C8000
!freeRAM = $1473

ORG $019D39
	LDA #$00
	JSL get_gfx
	
ORG $019D8F
	LDA #$00
	JSL get_gfx
	
ORG $019F24
	LDA #$00
	JSL get_gfx
	
ORG $019D95
	LDA #$03
	JSL get_gfx
	
ORG $019DF3
	LDA #$01
	JSL get_gfx
	
ORG $019DF9
	LDA #$02
	JSL get_gfx

ORG !freespace
db "STAR"
dw end-start
dw end-start^#$FFFF
start:
	get_gfx:
		PHP
		STA $09
		STZ $0A
		REP #$30
		PHX
		LDA !freeRAM
		AND #$00FF
		STA $06
		ASL
		CLC
		ADC $06
		TAX
		LDA.l pointer_table,X
		STA $06
		LDA #$0001
		AND $09
		BEQ +
			INC $06
		+
		SEP #$20
		LDA.l pointer_table+2,X
		STA $08
		PLX
		PLP
		PHY
		TXY
		LDA [$06],Y
		PLY
		PHA
		LDA #$02
		AND $09
		BEQ +
			PLA
			STA.w $0306,Y
			RTL
		+
		PLA
		STA.w $0302,Y
		RTL

pointer_table:
	dl $019B83
	dl tilemap				;Add more pointers here as needed, just make sure each has a unique name
		
tilemap:					;This is a copy of the original table, edit this as needed
	db $82,$A0,$82,$A2,$84,$A4,$8C,$8A	;Be sure to copy this table if you need another pointer
	db $8E,$C8,$CA,$CA,$CE,$CC,$86,$4E
	db $E0,$E2,$E2,$CE,$E4,$E0,$E0,$A3
	db $A3,$B3,$B3,$E9,$E8,$F9,$F8,$E8
	db $E9,$F8,$F9,$E2,$E6,$AA,$A8,$A8
	db $AA,$A2,$A2,$B2,$B2,$C3,$C2,$D3
	db $D2,$C2,$C3,$D2,$D3,$E2,$E6,$CA
	db $CC,$CA,$AC,$CE,$AE,$CE,$83,$83
	db $C4,$C4,$83,$83,$C5,$C5,$8A,$A6
	db $A4,$A6,$A8,$80,$82,$80,$84,$84
	db $84,$84,$94,$94,$94,$94,$A0,$B0
	db $A0,$D0,$82,$80,$82,$00,$00,$00
	db $86,$84,$88,$EC,$8C,$A8,$AA,$8E
	db $AC,$AE,$8E,$EC,$EE,$CE,$EE,$A8
	db $EE,$40,$40,$A0,$C0,$A0,$C0,$A4
	db $C4,$A4,$C4,$A0,$C0,$A0,$C0,$40
	db $07,$27,$4C,$29,$4E,$2B,$82,$A0
	db $84,$A4,$67,$69,$88,$CE,$8E,$AE
	db $A2,$A2,$B2,$B2,$00,$40,$44,$42
	db $2C,$42,$28,$28,$28,$28,$4C,$4C
	db $4C,$4C,$83,$83,$6F,$6F,$AC,$BC
	db $AC,$A6,$8C,$AA,$86,$84,$DC,$EC
	db $DE,$EE,$06,$06,$16,$16,$07,$07
	db $17,$17,$16,$16,$06,$06,$17,$17
	db $07,$07,$84,$86,$00,$00,$00,$0E
	db $2A,$24,$02,$06,$0A,$20,$22,$28
	db $26,$2E,$40,$42,$0C,$04,$2B,$6A
	db $ED,$88,$8C,$A8,$8E,$AA,$AE,$8C
	db $88,$A8,$AE,$AC,$8C,$8E,$CE,$EE
	db $C4,$C6,$82,$84,$86,$8C,$CE,$CE
	db $88,$89,$CE,$CE,$89,$88,$F3,$CE
	db $F3,$CE,$A7,$A9
end: