;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;translucent block fix
;made by Deflaktor
; -> credit not necessary
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

header
lorom

!NormalBlock = $79	;scratch ram - indicator that we are dealing with a normal block (not custom block)

!MiscData = $3FE00	;must be the same like in pipes.asm
!Map16Page = $04	;must be the same like in defs.asm
!MarioXPos = $7FFFF4	;must be the same like in pipes.asm
!MarioYPos = $7FFFF6	;must be the same like in pipes.asm


org $F199
JSL Main
NOP #2
;STA $04	;\ replaced opcodes
;LDA $00F080,x	;/

org !MiscData
	skip 51 	;skip 51 bytes to get to the code we need to change
	LDA !NormalBlock;are we dealing with a normal block (not custom block)
	CMP #$01
	STZ !NormalBlock;store zero in the scratch ram
	BEQ Return	;return if it is a normal block
	LDA $04		;here comes code from the pipes.asm
	CMP #!Map16Page
	BEQ SCoord
Return:	LDA #$08
	TSB $77
	RTL
SCoord:	LDA #$04
	STA $77
	PHP
	REP #$20
	LDA !MarioXPos
	STA $94                 ;Mario's X position (level, next frame)
	LDA !MarioYPos
	STA $96                 ;Mario's Y position (level, next frame)
	PLP
	RTL
	
Main:	PHA
	LDA #$01	;indicator that we are dealing with a normal block (not custom block)
	STA !NormalBlock;save it to scratch ram
	PLA
	STA $04		;execute replaced opcodes
	LDA $00F080,x
	RTL